// MEGSV4.cpp : Definiert den Einsprungpunkt fr die DLL-Anwendung.
/*#include <stdlib.h> 
#include <stdio.h>	s. stdafx.h
#include <windows.h>
#include <malloc.h>
#include <process.h>
#include <math.h>*/

//#pragma hdrstop
//#include "stdafx.h"

#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <LIMITS.H>
#include <FLOAT.H>
#include "MEGSV4w32.H"
#include "resource.h"

using namespace std;

//Compilerschalter
#define DUPLICATE_THREAD_HANDLE	//dupliziert den Thread-Handle (sicherer?)
#define	SLEEP_IN_THREAD	1	/*wenn def: Sleep(SLEEP_IN_THREAD) in thread aufger., wenn keine Bytes gelesen,
			//Wert: 1 oder 0, s. http://msdn.microsoft.com/en-us/library/ms686298%28VS.85%29.aspx:*/
#define WRITE_TIMEOUT_MULTIPLIER	2	//min Bus-Speed: 9600Bd, 10 Bits/Byte: 10000/9600 <2 ms pro byte
#define WRITE_TIMEOUT_CONSTANT	100	//in ms, wichtig wg.Schnittstellen-failure, dh ploetzlicher Komm.-Abbruch
		
//#define DEBUG_NO_HW_ACCESS	//Achtung: NIE hiermit releasen! Auskommentieren!!
//#define USE_NEW_ALLOCATION	//new statt malloc, delete statt free
#define CLR_THREADERR_ON_GETLASTERR //Thread-Error in GSV4getLastError loeschen
//#define STOPTX_ON_SET_COMMAND	//Beim GSV4 muss z.Zt. (Jun09) stopTX bei Kommandos gegeben werden
//#define STOPTX_ON_WRITE_COMMAND
//#define STOPTX_ON_READ_COMMAND
#define	SETFREQ_DIRECTINTERVAL	//setzt stets die naechsthoehere verhandene Datenrate, sonst: Interpolationsinterval
//#define GET_VERFILE_SYS_PROPERTY	//andere GSV4dllVersion Impl, mit Win-sys-Aufrufen. Unsicher, weglassen!!
//#define CHECK_POINTER_ARGS	//Uebergebene Zeiger testen mit IsBadWritePtr, ABER s. http://msdn.microsoft.com/en-us/library/aa366716(VS.85).aspx:
//"Important  This function is obsolete and should not be used." !!!

//Firmware-Versionsminima f. befehlsausfuehrung
#define FW_VER_MIN_DIO 0x0A	//f. SetGetDigital(-OnOff), Klaeren!!
#define FW_VER_MIN_DIO_EXT	0x10 //0x0C f. ver 1.13 auf 16 gesetzt!
/*Max- / Min-Werte, Parameter-related*/
#define	BAUD_NO	6	//Anzahl moeglicher Baudraten
#define CAN_BAUD_NO	8
#define	DATARATE_MIN 2.5/4	//Vorhandene Mindestfrequenz, nach FW-Update aendern!!
#define DATARATE_MAX_OLD 250 //reales Maximum, mit dem der GSV-4 z.Zt (08/2009) umgehen kann (vorhandenes Maximum 7500)
#define DATARATE_MAX_NEW 1000
#define DATARATE_NEWMAX_VERMIN 0x10
#define DATARATE_NUM 29	//Anzahl der gueltigen Datenraten
#define MODUS_MIN 0
#define MODUS_MAX 2
#define GAIN_MIN 1
#define GAIN_MAX 7	//geaendert, war 5!
#define THRES_NO_MIN	1	//Cmd. 20/21
#define	UNIT_LEN_MAX	5	//auch Parameteranzahl f. Cmd BC/BD SetGetUserString! belassen!
#define EMTY_UNIT_TXT_VAL ' '	//in GSV4setUnitText(0) Parameterwert f. Cmd BD, falls Laenge v. UnitTxt =0

#define	MAX_GSVS	256	//maximale Geraeteanzahl
#ifdef _DEBUG
	#define COMNO_MIN 0	//Com0: simulierter GSV-4
#else
	#define COMNO_MIN 1
#endif
#define IN_BUFSIZE	32768 //Windows-buffer incoming
#define OUT_BUFSIZE 256	//Windows-buffer outgoing
#define IN_OWNBUFSIZE	256	//Ablage fuer empfangene Bytes
#define PARAM_INBUF_SIZE 128 //fuer Parameterempfang
#ifdef TEST_GSV3
	#define	CHAN_NO	1	//Kanalanzahl eines GSV-4s
	#define	FRAME_SIZE 3
#else
	#define	CHAN_NO	4	//Kanalanzahl eines GSV-4s
	#define	FRAME_SIZE 11	//Messwertframegroesse 
#endif
#define RESPONSEFRAME_FIXEDSIZE 10	//Parameterantwortframe
#define PARAMRESPONSE_TIMEOUT 6000 //((10000/9600) * 50 * RESPONSEFRAME_FIXEDSIZE) // in ms
#define TIMEOUT_PURGE 100	/* Wartezeit beim Abbruch, bis erneuter Abbruch versucht wird */
#define PURGE_LOOP_MAX 15	/* Schleifenzaehler f. PurgeComm-Loop, Zeit: *TIMEOUT_PURGE ms */
#define STACK_SIZE 65536   /* Stapelgre fr "Hintergrund"-Thread */
#define MUTEX_MAX_WAITTIME 20000//Wartezeit fuer WaitSingleObject(io_mutex)
//#define RELEASE_WAIT_TIME 5000	//Wartezeit fuer GSV4release
#define WAIT_AFTER_STOPTX	200	//Wartezeit nach StopTx-Kommando innerhalb der Befehlsausfuehrung
#define MAX_BUS_LOAD 0.96	//maximale zeitliche Auslastung d. Schnittstellenbusses W: 0.1..1
#define WAIT_ACTIVATE 500 //Wartezeit am Ende der GSV4actExt in ms
#define WAIT_ACTIVATE_FACT 4	//mit ACTEX_FLAG_WAIT_EXTENDED: Wartezeit= WAIT_ACTIVATE*WAIT_ACTIVATE_FACT
#define TRIALS_GET_CMD 5	////mit ACTEX_FLAG_WAIT_EXTENDED: Anz. d. getMode-versuche in GSV4actExt
#define TIMEOUT_GSV_INIT 3000U   /* Erweitertes Timeout zB bei Handshake */
#define TIMEOUT_POLLFLOW 100U   /* Intervall fr Abfrage der Hardware-Flow-Control */
#define DELAY_BETWEEN_COMMANDS	80	//in ms, bei Schleifenaufrufen

#define MAX16BIT 0xFFFF
#define BIPOLAR_ZERO 0x8000   /* entspricht 0 im bipolar-Modus*/
#define RANGE_FACTOR ((double)1.05)   /* Faktor zur Skalierung auf den "Vollausschlag" */
#define BIPOLAR_SCALE (2 * RANGE_FACTOR / MAX16BIT) 

//Messwert-status
#define	VAL_STAT_NOVAL 0
#define	VAL_STAT_IS_GOODVAL	1
#define	VAL_STAT_VALERROR	0xFF

#pragma pack(push, 4)	//noetig??

#define DATA_KEY 0xA5
#define	DATA_POSTFIX_1	0x0D
#define	DATA_POSTFIX_2	0x0A
#define PARAM_KEY 0x3B

//DigIO-Type offsets & ranges
#define DIGIO_NO_MAX	8
#define DIGIO_NO_MAX_EXT	12
#define DIGIO_NO_MIN	1
#define DIGIOTYPE_OFFSET_TARA	7
#define DIGIOTYPE_RANGE_TARA	0x0A
#define DIGIOTYPE_OFFSET_SW	9
#define DIGIOTYPE_RANGE_SW	0x11
#define DIGIOTYPE_OFFSET_SYNC	1
#define DIGIOTYPE_RANGE_SYNC	0x0F
#define DIGIOTYPE_REG_MAX	0x18
#define DIGIO_TYPE_NO_MAX 15
#define DIGIO_TYPE_NO_MAX_EXT 17

/*Makros*/
#define ABORT_ACTIVATE \
	ReleaseGSV(ComNo); \
   return -1
/*if(tmpGSV->hcom)		\
   	CloseHandle(tmpGSV->hcom); \*/
   
#define CHECK_COMNO \
	 if (ComNo < COMNO_MIN || ComNo >= MAX_GSVS || gsvs[ComNo].ComNr != ComNo || gsvs[ComNo].ownPtr==NULL) \
     {	\
		gsvs[ComNo].LastError= ERR_WRONG_COMNO;	\
		return GSV_ERROR;	\
	 }
#define CHECK_CHAN \
	if(Chan<1 || Chan >CHAN_NO) \
	{	\
		gsvs[ComNo].LastError= ERR_WRONG_PARAMETER;	\
		return GSV_ERROR;	\
	}
#define CHECK_CHAN_ALL \
	if(Chan<0 || Chan >CHAN_NO) \
	{	\
		gsvs[ComNo].LastError= ERR_WRONG_PARAMETER;	\
		return GSV_ERROR;	\
	}

#define STOP_TX \
	if(gsvs[ComNo].GSVtxOn) \
	{			\
		if(StopTX(ComNo)==GSV_ERROR) \
			return GSV_ERROR; \
		Sleep(WAIT_AFTER_STOPTX); \
	}
#define START_TX \
	if(gsvs[ComNo].GSVtxOn) \
	{			\
		if(StartTX(ComNo)==GSV_ERROR) \
			return GSV_ERROR; \
	}
#define CALC_GSV_DATA(in) (((double)(in)) - BIPOLAR_ZERO) * BIPOLAR_SCALE

#define RES_GETLASTERROR \
	{	\
		gsvs[ComNo].LastError= GetLastError() | OWN_ERR_MASK; \
		res= GSV_ERROR; \
	}
#define RES_CHK_BYTES_WRITTEN(no) \
	else if(Byteswritten != (no))	\
	{	\
		gsvs[ComNo].LastError= ERR_BYTES_WRITTEN; \
		res= GSV_ERROR;	\
	}

#define RET_WRONG_PARAMETER	\
	{	\
		gsvs[ComNo].LastError= ERR_WRONG_PARAMETER;	\
		return GSV_ERROR;	\
	}
#define RES_MUTEXFAILED	\
	{	\
		gsvs[ComNo].LastError= ERR_MUTEXFAILED; \
		res= GSV_ERROR; \
	}
#define RES_CHK_PARAM_COUNT(num) \
	if(res==GSV_OK) \
	{	\
		if(gsvs[ComNo].Param_in_count != (RESPONSEFRAME_FIXEDSIZE + (num))) \
		{	\
			gsvs[ComNo].LastError= ERR_WRONG_ANSWER_NUM; \
			res= GSV_ERROR; \
		}	\
	}
	
#define RES_NO_GSVANSWER	\
	{	\
		if(res==GSV_TRUE) \
		{	\
			gsvs[ComNo].LastError= ERR_NO_GSV_ANSWER; \
			res= GSV_ERROR; \
		}	\
	}

#define WRITE_BYTES_CHK_SUCC(num)	\
	if(!WriteFile(gsvs[ComNo].hcom, txbuf, (num), &Byteswritten, NULL)) \
	{	\
		gsvs[ComNo].LastError= GetLastError() | OWN_ERR_MASK; \
		res= GSV_ERROR; \
	}	\
	else if(Byteswritten != (num))	\
	{	\
		gsvs[ComNo].LastError= ERR_BYTES_WRITTEN; \
		res= GSV_ERROR;	\
	}

#define CHECK_FW_VERSION(ver)	\
	if(gsvs[ComNo].FWversion < (ver))	\
	{	\
		gsvs[ComNo].LastError= ERR_NOT_SUPPORTED;	\
		return GSV_ERROR;	\
	}	
//Strukte
#ifdef _DEBUG
typedef struct _gsvparam	//fuer simulierten GSV4, nimmt einige Betriebsparameter auf
{
	unsigned int period; //= 1000/datarate +1 ms
	unsigned char drcode; //datarate-code
	double norm[4];
	unsigned long unit;
	unsigned long MWcnt;
	unsigned char mode;
	//unsigned long serno;
	unsigned char gain[4];
	HANDLE hTimer;
    //HANDLE hTimerQueue;
	int endTimer;
	HANDLE bufmutex;
    int arg;
	unsigned char emulbuf[32];	//f. max 1 MW-frame
	bool buf_filled;
	int ebufpos;
	int counter;
} gsvparam;
#endif

typedef struct _gsvdata
{
	volatile long value[CHAN_NO];
	volatile unsigned char status; //[4];   /* Status*/
} gsvdata;
	

typedef struct _gsvrecord	//fuer je 1 GSV-4 mit CHAN_NO=4 Kanaelen
{
	volatile void *ownPtr;
	HANDLE hcom;	//Schnittstelle
	COMMTIMEOUTS timeouts;
	long ComNr;
	long Bitrate;
	unsigned char *in_buffer;   /* Lesepuffer (Zeiger) */
	//unsigned long in_size;
   	unsigned long in_pos;   /* Lesepuffer aktuelle Lese-Position */
   	unsigned long in_count;   /* Lesepuffer Anzahl Bytes */
   	unsigned long in_missing;   /* Lesepuffer Anzahl fehlende Bytes, */
   /* um einen Datenrecord oder Parameterrecord vervollstndigen zu knnen */
   	HANDLE thread; //HANDLE thread;
   	HANDLE thread_h;
   	int terminate;	//=1: Thread beenden
   	int is_terminated;
   	HANDLE	io_mutex;	//f. Messwerte lesen (Zugriff auf out_buffer)
	HANDLE Prd_mutex;	//f. Parameter lesen (Zugriff auf Param_in_buf)
	HANDLE Prd_event;	//Signal: Alle (Lese-) Parameter fertig empfangen
	HANDLE Clr_event;	//Signal: in_buffer geloescht
	//gsvdata LastValue[CHAN_NO];
	unsigned long *out_buffer[CHAN_NO];   /* Lesepuffer (Zeiger) */
	unsigned long out_size;
	volatile unsigned long out_put[CHAN_NO];   /* Datenpuffer Einfgeposition */
   volatile unsigned long out_get[CHAN_NO];   /* Datenpuffer Entnahmeposition */
   volatile unsigned long out_count[CHAN_NO];   /* Datenpuffer Datensatzanzahl */
   volatile unsigned char* Param_in_buf;	//Ablage f. Read-Parameter
   //volatile unsigned long Param_in_pos;
   volatile unsigned long Param_in_count;
   volatile unsigned long Param_in_missing;
   volatile DWORD error;   /* Ablage fr Fehler-Code, write-Zugriff NUR im Lesethread*/
   	BOOL clear;	//=1: Buffer loeschen
   	BOOL GSVtxOn;	//=1: Staendige Messwertuebertragung des GSV ist an
	unsigned long FWversion;	//MERGSV$ v.1.1.: Firmware-Version speichern (wenn kommuniziert), sonst =0
	volatile unsigned long LastError;	//jetzt Member, write-Zugriff in Fkt, NICHT im Thread
} gsvrecord;

static unsigned long LastErrorGlobal;	//Errorcode, nur (noch) fuer GSV4actExt
static int LastErrorIndex;

#ifdef GET_VERFILE_SYS_PROPERTY
/* hier wird die Modul-Instanz fr GSVVersion gemerkt */
	static HINSTANCE module_inst = 0;
#endif
//static Arrays
/*Array der GSVs*/
static gsvrecord gsvs[MAX_GSVS];

static	long baud_table[] =
{
   //4800,
   9600,  19200, 38400, 57600, 115200, 230400
};

#ifdef _DEBUG
	static gsvparam GSVsim;
#endif

/*Main-entry-point, Initialisierungen durchfuehren*/
BOOL CALLTYPE DllMain( HANDLE hModule,	//war BOOL APIENTRY 
                       DWORD  fdwReason, 
                       LPVOID lpReserved )
{
	int i;
	switch (fdwReason)
	    {
	        case DLL_PROCESS_ATTACH:
	        	/*for(i=0;i<MAX_GSVS;i++)
	        	{
	        		gsvs[i].hcom= NULL;
	        		gsvs[i].timeouts= NULL;
	        		gsvs[i].ComNr= 0; //sinnvoller init-wert?
	        		for(k=0;k<CHAN_NO;k++)
	        			gsvs[i].LastValue[k].status= VAL_STAT_NOVAL;
	        	}*/
	        	memset(gsvs, 0, MAX_GSVS * sizeof(gsvrecord));	//gsv-Array mit 0 fuellen
#ifdef _DEBUG
				memset(&GSVsim, 0, sizeof(gsvparam));
#endif
	            break;
	        case DLL_THREAD_ATTACH:
	            break;
	        case DLL_THREAD_DETACH:
	            break;
	       case DLL_PROCESS_DETACH:
	       	for(i=0;i<MAX_GSVS;i++)	//to do: Bereinigungsroutine
	       	{
	       		/*if(gsvs[i].hcom)
	       			CloseHandle(gsvs[i].hcom);*/
				if(gsvs[i].ownPtr)
					GSV4release(gsvs[i].ComNr);
	       	}
	            break;
	    }
    /* The return value is used for successful DLL_PROCESS_ATTACH */
    return TRUE;
}

#ifdef _DEBUG
//VOID CALLBACK TimerAPCProc(LPVOID lpArg, DWORD dwTimerLowValue, DWORD dwTimerHighValue ) 	//, BOOLEAN TimerOrWaitFired
unsigned __stdcall GSVsimTimer(void* ptr)
{
	int i;
	//if(lpArg==NULL)
	//	return;
	if(gsvs[0].ownPtr==NULL)
		return 0;

	while(!GSVsim.endTimer)
	{
		if(WaitForSingleObject(GSVsim.bufmutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0)
		{
			if(GSVsim.buf_filled==false)
			{
				GSVsim.emulbuf[0]= DATA_KEY;
				for(i=1;i<=8;i+=2)
				{
					GSVsim.emulbuf[i]= 0x80 + (i<<4);
					GSVsim.emulbuf[i+1]= 0x00;
				}
				GSVsim.emulbuf[FRAME_SIZE-2]= DATA_POSTFIX_1;
				GSVsim.emulbuf[FRAME_SIZE-1]= DATA_POSTFIX_2;
				GSVsim.buf_filled= true;
				GSVsim.ebufpos=0;
			}
			ReleaseMutex(GSVsim.bufmutex);
		}
		Sleep(GSVsim.period);
	}
	return 0;
}
bool initGSVparam()
{
	/*__int64         qwDueTime;
   LARGE_INTEGER   liDueTime;*/
   DWORD ret;
   unsigned threadID;

	/*HANDLE hTimer = NULL;
    HANDLE hTimerQueue = NULL;
    int arg = 123;*/
	
	//TIMECAPS timerProps;
	//if(timeGetDevCaps(&timerProps,sizeof(TIMECAPS) ==MMSYSERR_NOERROR)
	// Create the timer queue.
    /*GSVsim.hTimerQueue = CreateTimerQueue();
	if(GSVsim.hTimerQueue==NULL)
		return false;
	if (!CreateTimerQueueTimer( &GSVsim.hTimer, GSVsim.hTimerQueue, (WAITORTIMERCALLBACK)TimerRoutine, &arg , GSVsim.period, GSVsim.period, 0))
		return false;*/
   GSVsim.period= (unsigned int)(1000/12.5) +1;
   //qwDueTime = -10 * GSVsim.period;

         // Copy the relative time into a LARGE_INTEGER.
   //liDueTime.LowPart  = (DWORD) ( qwDueTime & 0xFFFFFFFF );
   //liDueTime.HighPart = 0xFFFFFFFF; //(LONG)  ( qwDueTime >> 32 );
   //liDueTime.QuadPart = -100000000L;

	GSVsim.bufmutex= CreateMutex(NULL, TRUE, NULL);
	if(GSVsim.bufmutex==NULL)
		return false;
	GSVsim.ebufpos=0;
	GSVsim.period= (unsigned int)(1000/12.5) +1;
	GSVsim.drcode= 0xA6;
	GSVsim.unit= 0;
	GSVsim.MWcnt= 0;
	GSVsim.mode= 0;
	//GSVsim.serno= 12345678;
	for(int i=0;i<4;i++)
	{
		GSVsim.gain[i]= 1;
		GSVsim.norm[i]= 1;
	}
	ReleaseMutex(GSVsim.bufmutex);

	/*GSVsim.hTimer= CreateWaitableTimer(NULL, FALSE, "MyTimer");
	if(GSVsim.hTimer==NULL)
			return false;
	if(!SetWaitableTimer(GSVsim.hTimer, &liDueTime, GSVsim.period, GSVsimTimer, &GSVsim.arg, FALSE))
		return false;
	ret= WaitForSingleObjectEx(GSVsim.hTimer, INFINITE, TRUE);
	if(ret==WAIT_OBJECT_0 || ret==WAIT_IO_COMPLETION)
		return true;
	else return false;*/
	GSVsim.endTimer =0;
	GSVsim.hTimer = (HANDLE)_beginthreadex(NULL,STACK_SIZE, &GSVsimTimer, (gsvrecord*)&gsvs[0], 0, &threadID); //tmpGSV);
	if(GSVsim.hTimer)
	{
		GSVsim.arg =1; //signalisiert Vorhandensein des GSV-Simulators
		return true;
	}
	else return false;
}
int ReadGSVsim(unsigned char* bufpos, long toRead, unsigned long* NumRead)	//Aufruf durch ThreadFkt statt ReadFile
{
	int i;

	if(WaitForSingleObject(GSVsim.bufmutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		if(GSVsim.buf_filled && toRead)
		{
			for(i=0;i<toRead;i++)
				*(bufpos+i)= GSVsim.emulbuf[GSVsim.ebufpos+i];
			GSVsim.ebufpos += toRead;
			if(GSVsim.ebufpos >= FRAME_SIZE)
				GSVsim.buf_filled= false;
			*NumRead= toRead;
		}
		else
			*NumRead=0;
		ReleaseMutex(GSVsim.bufmutex);
	}
	else
		*NumRead=0;
	return 1;
}
#endif // _DEBUG

/* Analysieren eingegangener Daten, ggf nach out_buffer kopieren. Called by thread */
static void move_gsv_data(gsvrecord *tmp)
{
   unsigned long j;
   unsigned char *p;

   j = tmp->in_count;   /* Anzahl Bytes */
   p = tmp->in_buffer;   /* Hier starten */
   tmp->in_missing = 0;   /* Resultat voreinstellen auf 0 */

   while (j)
   {
      gsvdata t;
      unsigned long inx;
	  char suffix[2];
#ifdef _DEBUG
	//	Beep(2000,200);
#endif
      /* Datenrecord gefunden */
      if (*p == DATA_KEY)
      {
         /* Sind gengend Daten da, um den Record vollstndig zu verarbeiten ? */
         if (j < FRAME_SIZE)
         {
            /* Wenn nein, Abbrechen und fehlende Byte-Anzahl angeben */
            tmp->in_missing = FRAME_SIZE - j;
            break;
         }

         /* Restanzahl berechnen */
         j -= FRAME_SIZE;
         p++;

         //t.status[0] = *p++;

         /* Datenbytes umkopieren in der richtigen Reihenfolge */
         /* so da ein 32-Bit Wert entsteht */
         //inx = (unsigned long)sizeof(unsigned long);
//#ifndef TEST_GSV3
		for(inx=0;inx<CHAN_NO;inx++)
		{
//#else
//#endif
			 *((unsigned char *)&t.value[inx] + 3) = 0; // remember: C is low-endian
			 *((unsigned char *)&t.value[inx] + 2) = 0;	//
			 *((unsigned char *)&t.value[inx] + 1) = *p++;	//gsvData Hbyte
			 *((unsigned char *)&t.value[inx]) = *p++;	//gsvData Lbyte

		}
#ifndef TEST_GSV3
		suffix[0]= *p++;
		suffix[1]= *p++; //letztes incremnent noetig
		if (suffix[0] == DATA_POSTFIX_1 && suffix[1] == DATA_POSTFIX_2)	//GSV4 hat Postfix lf,cr
		{
			t.status = VAL_STAT_IS_GOODVAL;
		}
		else
		{
			t.status= VAL_STAT_VALERROR;
			tmp->error= ERR_WRONG_FRAME_SUFFIX; //error-Var des Threads setzen
			break;	//suffix-error: while-loop abbrechen
		}
#endif
		 /* geschtzten Daten-Lese-Bereich betreten */
		 DWORD retv= WaitForSingleObject(tmp->io_mutex, MUTEX_MAX_WAITTIME);	//INFINITE
		  if (retv==WAIT_OBJECT_0) //!= WAIT_FAILED) 
		  {
				/* berspringen, wenn Buffer clear gefordert */
			 if (!tmp->clear)
			 {
				/* Wert und Status in Datenpuffer legen und */
				/* Zeiger etc. anpassen */
#ifdef TEST_GSV3
				if (tmp->out_count[0] < tmp->out_size)
				   tmp->out_count[0]++;
				else
				   tmp->out_get[0] = (tmp->out_get[0] + 1) % tmp->out_size;	
				//tmp->out_buffer[tmp->out_put] = *pd;
				*(tmp->out_buffer[0]+tmp->out_put[0])= t.value[0];
				tmp->out_put[0] = (tmp->out_put[0] + 1) % tmp->out_size;
#else
				for(inx=0;inx<CHAN_NO;inx++)
				{
					if (tmp->out_count[inx] < tmp->out_size)
					   tmp->out_count[inx]++;
					else				//Buffer voll: alte Werte ueberschreiben
					   tmp->out_get[inx] = (tmp->out_get[inx] + 1) % tmp->out_size; 

					*(tmp->out_buffer[inx]+tmp->out_put[inx])= t.value[inx];
					tmp->out_put[inx] = (tmp->out_put[inx] + 1) % tmp->out_size;
				}
#endif
			 }
			  /* geschtzten Daten-Lese-Bereich verlassen */
			ReleaseMutex(tmp->io_mutex);

			 /* ganz abbrechen, wenn Buffer clear gefordert */
			 if(tmp->clear)
				 return;
		 }
		  else
			  tmp->error= ERR_MUTEXFAILED;
		  //else printf("mutex gescheitert. Code: %d",tmp->error);
    }
	else if(*p == PARAM_KEY)	//Parameter-prefix gefunden
	{
		if(WaitForSingleObject(tmp->Prd_mutex, INFINITE)==WAIT_OBJECT_0) // != WAIT_FAILED) Param_in_..Zugriff sperren
		{
			if(tmp->Param_in_missing)	//wenn Parameter erwartet werden:
			{
				tmp->Param_in_count = j;	//bereits empfangene Byteanzahl setzen.
				if (j < tmp->Param_in_missing)	//schon alle erwarteten Bytes empfangen?
				 {
					/* Wenn nein, Abbrechen und fehlende Byte-Anzahl angeben */
					tmp->in_missing = tmp->Param_in_missing - j;
					ReleaseMutex(tmp->Prd_mutex);	//Zugriff wieder freigeben
					break;						// while schleife abbrechen
				 }
				j -= tmp->Param_in_missing;	//sonst: unverarbeitete Restgroesse aktualisieren
				//p++;		PARAM_KEY mitkopieren
				for(inx=0;inx<tmp->Param_in_missing;inx++)	//ganzen Parameterframe nach Param_in_buf kopieren
				{
					*(tmp->Param_in_buf+inx)= *p++;
				}
				tmp->Param_in_missing=0;		//da alle da, keine Parameter mehr erwarten
				if(!SetEvent(tmp->Prd_event))	//Event fuer Lesefunktion setzen
					tmp->error= GetLastError(); //ERR_EVENTFAILED;
			}
			else
			{		//zwar (scheinbar) Data-Praefix, aber keine Daten erwartet: ignorieren
				 p++;
				 j--;
#ifdef _DEBUG
				Beep(2000,50); //beim debug piepen, um (schein-) datenfehler anzuz.
#endif
			}
			ReleaseMutex(tmp->Prd_mutex);	//Param_in_..-Zugriff wieder freigeben
		}
		else
			tmp->error= ERR_MUTEXFAILED;
	}
	  /* sonstige Zeichen */
    else
    {
         /* ignorieren */
         p++;
         j--;
#ifdef _DEBUG
		Beep(2000,50);
#endif
    }
   }	//end while (j)
   /* unverarbeiteten Rest an den Anfang des Puffers kopieren */
   /* und Position zum Anfgen setzen */
   if (j)
   {
      memmove(tmp->in_buffer, p, j);
      tmp->in_pos = j;
   }
}
   
/*Thread-Execution*/
unsigned __stdcall gsv_data_pump(void *ptr) //war static void 
{
	gsvrecord *tmp = (gsvrecord *)ptr;   /* Zeiger auf GSV-Datensatz */
   BOOL res;
   DWORD err;

   /* Solange keine Beendigung gewnscht */
   while (!tmp->terminate)
   {
	tmp->in_count = 0;

      /* Wenn keine besondere Anforderung, dann 1 Byte Lesen, */
      /* um den Beginn eines Records analysieren zu knnen */
      if (!tmp->in_missing)
         tmp->in_missing = 1;

      /* Lesen */
#ifdef _DEBUG
	  if(tmp->ComNr ==0)
		res= ReadGSVsim(tmp->in_buffer + tmp->in_pos, tmp->in_missing, &tmp->in_count);
	  else
#endif
      res = ReadFile(tmp->hcom, tmp->in_buffer + tmp->in_pos,
                     tmp->in_missing, &tmp->in_count, NULL); //&tmp->action_read);
	  if(res)
	  {
#ifdef SLEEP_IN_THREAD
		   if(!tmp->in_count)	//wenn nix gelesen:
				Sleep(SLEEP_IN_THREAD);	//Suspend the execution of the current thread
#endif
	  }
	  else
		  err= GetLastError();
      //err = res ? ERROR_SUCCESS : GetLastError();
	if (res || (tmp->clear && err == ERROR_OPERATION_ABORTED))
      {
         /* Wenn Buffer-Clear gefordert */
         if (tmp->clear)
         {
            /* Lesepuffer lschen */
            tmp->in_count = 0;
            tmp->in_pos = 0;
            tmp->in_missing = 0;

            /* Lschanforderung zurcksetzen */
            tmp->clear = FALSE;
			if(!SetEvent(tmp->Clr_event)) //und quittieren
				tmp->error= GetLastError(); //ERR_EVENTFAILED;
			else
				tmp->error= 0;	//evtl. alten fehler loeschen
         }
		 else
		{
            /* Anzahl um vorher bereits vorhandene Anzahl erhhen */
            tmp->in_count += tmp->in_pos;
            /* Wieder von ganz vorne beginnen */
            tmp->in_pos = 0;

            /* Eingegangene Daten analysieren */
		if(tmp->in_count)	//runtime-optim.: nur call, wenn was gelesen
			 move_gsv_data(tmp);
         }
	}	
	else	//ReadFile returned error:
	{	//ERROR_IO_PENDING ist kein Fehler, s. http://msdn.microsoft.com/en-us/library/aa365467%28VS.85%29.aspx
		if(err != ERROR_IO_PENDING && !tmp->clear)
		{
			tmp->error = err;
			//tmp->LastError= err | OWN_ERR_MASK;
		}
#ifdef _DEBUG
		Beep(500,1000);
#endif
#ifdef SLEEP_IN_THREAD
		Sleep(SLEEP_IN_THREAD);
#endif
	}
   }
   if(tmp->terminate)	//TODO: Testen: ok
   {
	 /* Thread beenden */
		_endthreadex(0);
		tmp->is_terminated=1;
   }
	return 0;
}
	
/*int EnterGSVreadMutex(int no)	//to do: Makro bauen
{
	//int result,j;

   // Grundstzliche Zulssigkeit 
   if (no < 0 || no >= MAX_GSVS)
      return FALSE;
	if(gsvs[no].ownPtr==NULL)  //ist der Eintrag "no" wirklich gltig ?
		return FALSE;

	if (WaitForSingleObject(gsvs[no].io_mutex, INFINITE) == WAIT_FAILED)
         return FALSE;
	else return TRUE;
}

static __inline double CalcGSVdata(long input)	
{
	return ((double)(input - BIPOLAR_ZERO)) * BIPOLAR_SCALE;
}*/

/* Runden mit Vorzeichen */
static long sl_round(double v)
{
   return v < 0 ? (long)(v - 0.5) : (long)(v + 0.5);
}
static __inline int GetBitValue(long in, int bitNo)	//BitNo: 0..31!!
{
	//int Mask;

	if(bitNo>31)
		return -1;

	//Mask= 1 << bitNo;
	//return (in >> bitNo) & Mask;
	return (in >> bitNo) & 1;	//Korrektur 1.13
}
static __inline int MakeBitMask(long in, int bitNo)
{
	int Mask;

	if(bitNo>31)
		return -1;
	Mask= 1 << bitNo;
	if(in)
		return Mask;
	else
		return Mask^0xFFFFFFFF;
}
/* Verzgerung in Millisekunden */
static void short_delay(DWORD dly)
{
   DWORD acnt, tcnt = GetTickCount();

   Sleep(dly);

   while ((acnt = GetTickCount() - tcnt) <= dly)
      Sleep(acnt);
}

void ReleaseGSV(int ComNo)
{
	DWORD wtr,i, wtrCnt;
	HANDLE tmpH;

	if(gsvs[ComNo].ownPtr == NULL)
		return;
	if (gsvs[ComNo].Prd_event)
         	ResetEvent(gsvs[ComNo].Prd_event);
#ifdef _DEBUG
	if(ComNo==0)
	{
		GSVsim.endTimer =1;
		GSVsim.arg =0;
	}
		//CloseHandle(GSVsim.hTimer);
#endif
	gsvs[ComNo].terminate =1;
	/*while(!gsvs[ComNo].is_terminated && wait<RELEASE_WAIT_TIME)
	{
		Sleep(1);
		wait++;
	}
	tmp->is_terminated=0; noetig?*/
	if (gsvs[ComNo].thread)
    	{  
#ifdef DUPLICATE_THREAD_HANDLE
		tmpH= gsvs[ComNo].thread_h != NULL ? gsvs[ComNo].thread_h : (HANDLE)gsvs[ComNo].thread;
#else
		tmpH= gsvs[ComNo].thread;
#endif
         	gsvs[ComNo].clear = TRUE;   /* Auch Buffer-Clear setzen zur Vereinfachung */

         	if (gsvs[ComNo].hcom)   /* Einlesevorgnge abbrechen */
            		PurgeComm(gsvs[ComNo].hcom, PURGE_RXABORT | PURGE_RXCLEAR);
		/* MUTEXs freigeben, da Arrayeintrge bereits leer sind, */
        	 /* gibt es nichts mehr zu schtzen */
         	if (gsvs[ComNo].io_mutex != NULL)
		 {
            		ReleaseMutex(gsvs[ComNo].io_mutex);
			gsvs[ComNo].io_mutex=NULL;
		 }
         	if (gsvs[ComNo].Prd_mutex != NULL)
		 {
            		ReleaseMutex(gsvs[ComNo].Prd_mutex);
			gsvs[ComNo].Prd_mutex=NULL;
		 }
		if (gsvs[ComNo].hcom)
        	 {
        	 	wtrCnt=PURGE_LOOP_MAX; //neu ver 1.15: sicherer wg. PurgeComm Problem bei einigen Treibern wie usbser.sys
            	do
            	{
               	/* Sicherstellen, da der Thread tatschlich noch existiert */
               		DWORD exitcode;
               		if (GetExitCodeThread(tmpH, &exitcode))
                  	if (exitcode != STILL_ACTIVE)
                     		break;
			wtrCnt--;
               		/* Warten auf Beendigung des "Hintergrund"-Threads */
               		wtr = WaitForSingleObject(tmpH, TIMEOUT_PURGE);

              		 /* Falls Timeout: nochmal Einlesen abbrechen und weiterwarten */
               		if (wtr == WAIT_TIMEOUT)
                  		PurgeComm(gsvs[ComNo].hcom, PURGE_RXABORT);

            	} while (wtr == WAIT_TIMEOUT && wtrCnt>0);
         }
		 	/* Thread endgltig schlieen */
#ifdef DUPLICATE_THREAD_HANDLE
	if (gsvs[ComNo].thread_h != NULL)
	 {
            CloseHandle(gsvs[ComNo].thread_h);
		gsvs[ComNo].thread_h=NULL;
	 }
#else
         if (gsvs[ComNo].thread != NULL)
	 {
            CloseHandle(gsvs[ComNo].thread);
		gsvs[ComNo].thread=NULL;
	 }
#endif
	}
	if (gsvs[ComNo].hcom)
	{
         /* alle Operationen abbrechen und alle Puffer lschen */
         PurgeComm(gsvs[ComNo].hcom, PURGE_RXABORT | PURGE_TXABORT |
                            PURGE_RXCLEAR | PURGE_TXCLEAR);

         /* serielle Schnittstelle schlieen */
         CloseHandle(gsvs[ComNo].hcom);
		 gsvs[ComNo].hcom= NULL;
    }
	/* nicht mehr bentigte Events schlieen */
	if(gsvs[ComNo].Prd_event)
	{
		CloseHandle(gsvs[ComNo].Prd_event);
		gsvs[ComNo].Prd_event=NULL;
	}
	if(gsvs[ComNo].Clr_event)
	{
		CloseHandle(gsvs[ComNo].Clr_event);
		gsvs[ComNo].Clr_event=NULL;
	}

	if(gsvs[ComNo].in_buffer)
	{
#ifdef USE_NEW_ALLOCATION
		delete gsvs[ComNo].in_buffer; //, IN_OWNBUFSIZE);	//gsvs[ComNo].in_size
	}
	for(i=0;i<CHAN_NO;i++)
	{
		if(gsvs[ComNo].out_buffer[i])
			delete gsvs[ComNo].out_buffer[i]; //, gsvs[ComNo].out_size[i]*sizeof(long));
	}
#else
		free(gsvs[ComNo].in_buffer);
		gsvs[ComNo].in_buffer=NULL;
	}
	for(i=0;i<CHAN_NO;i++)
	{
		if(gsvs[ComNo].out_buffer[i])
		{
			free(gsvs[ComNo].out_buffer[i]);
			gsvs[ComNo].out_buffer[i]=NULL;
		}
	}
#endif
	
	if(gsvs[ComNo].io_mutex)
	{
		ReleaseMutex(gsvs[ComNo].io_mutex);	//noetiG??
		gsvs[ComNo].io_mutex= NULL;
		//CloseHandle(gsvs[ComNo].io_mutex);
	}
	gsvs[ComNo].ownPtr= NULL;
	gsvs[ComNo].ComNr= 0;
}

long CALLTYPE GSV4dllVersion(void)
{
#ifdef GET_VERFILE_SYS_PROPERTY
   long result = GSV_ERROR;
   char filename[2 * MAX_PATH];
   DWORD isize, dummy;
   UINT len;
   VS_FIXEDFILEINFO *fixed_info;

   /* Die Version wird bestimmt durch Zugriff auf die */
   /* VersionInfo Resource des eigenen .DLL-Files */

   if (GetModuleFileName(module_inst, filename, sizeof(filename) - 1)) //ist leider \...\gsv4test.exe
   {
      isize = GetFileVersionInfoSize(filename, &dummy);
      if (isize)
      {
         void *buffer = alloca(isize);

         if (buffer)
         {
            if (GetFileVersionInfo(filename, dummy, isize, buffer))
            {
               if (VerQueryValue(buffer, "\\", (LPVOID *)&fixed_info, &len))
               {
                  if (len >= sizeof(VS_FIXEDFILEINFO))
                     result = (long)fixed_info->dwFileVersionMS;
               }
            }
         }
      }
   }
   return result;
#else
   return (FILEVER_H * 65536) + FILEVER_L;	//Besser!. ToDo: Version NUR in resource.h aendern!!
#endif
}

int CALLTYPE GSV4actExt(int ComNo, long Bitrate, long BufSize)
{
	return GSV4activateExtended(ComNo, Bitrate, BufSize, 0);
}

int CALLTYPE GSV4activateExtended(int ComNo, long Bitrate, long BufSize, long flags)
{
	int i,ret,mode;
	long max_s, bufsizetmp;
	BOOL baudok=false;
	char portstr[16];
	COMMTIMEOUTS Timeout;
	DCB dcb;
	//HANDLE tmp=NULL;
	gsvrecord *tmpGSV = NULL;
	HANDLE i_mutex = NULL;
	HANDLE rd_mutex = NULL;
	HANDLE myevent, clrevent;
	unsigned threadID;
	unsigned long wtime;

	LastErrorIndex= ComNo;	//f. GetLastError-Abfrage
		/* Grundstzliche Zulssigkeit */
   if(ComNo<COMNO_MIN || ComNo>=MAX_GSVS)
   {
	   LastErrorGlobal= ERR_WRONG_COMNO;
	   return GSV_ERROR;
   }
	/* Datenpuffer: Gre berprfen und anlegen */
	   max_s = (long)(((DWORD)-1) / FRAME_SIZE);
	
	if(BufSize<1)
		BufSize=1;
	else if (BufSize > max_s)
	      bufsizetmp = max_s;
	else bufsizetmp= BufSize;
	      
	for(i=0;i<BAUD_NO;i++)	//baudrate checken
	{
	  	if(baud_table[i]==Bitrate)
		{
	   		baudok= true;
			break;
		}
	}
	if(!baudok)
	   //	RET_WRONG_PARAMETER;
	{
		LastErrorGlobal= ERR_WRONG_PARAMETER;
		return GSV_ERROR;
	}
/*#ifdef _DEBUG
	if(ComNo==0)
	{
		if(GSVsim.arg)
		{
			LastErrorGlobal= ERR_COM_ALREADY_OPEN;
		   	return GSV_ERROR; 
		}
	}
	else
	{
#endif*/
	if(gsvs[ComNo].hcom!=NULL || gsvs[ComNo].ownPtr !=NULL)
	{
		LastErrorGlobal= ERR_COM_ALREADY_OPEN;
	   	return GSV_ERROR; 	//Schnittstelle bereits geoeffnet
	}
/*#ifdef _DEBUG
	}
#endif*/
	i_mutex = CreateMutex(NULL, TRUE, NULL);
   	if (i_mutex == NULL)
    {
		LastErrorGlobal= ERR_MUTEXFAILED;
	   	return GSV_ERROR; 	//windows gewaehrt keinen mutex
	}
	rd_mutex= CreateMutex(NULL, TRUE, NULL);
	if (rd_mutex == NULL)
    {
		LastErrorGlobal= ERR_MUTEXFAILED;
	   	return GSV_ERROR; 	//windows gewaehrt keinen mutex
	}
#ifdef _DEBUG
	myevent= CreateEvent(NULL,FALSE,FALSE,NULL);
#else
	myevent= CreateEvent(NULL,TRUE,FALSE,NULL);
#endif
	if(myevent==NULL)
	{
		LastErrorGlobal= ERR_EVENTFAILED;
	   	return GSV_ERROR; 	//windows gewaehrt keinen event-handler
	}
	clrevent= CreateEvent(NULL,FALSE,FALSE,NULL);
	if(clrevent==NULL)
	{
		LastErrorGlobal= ERR_EVENTFAILED;
	   	return GSV_ERROR; 	//windows gewaehrt keinen event-handler
	}
	tmpGSV = (gsvrecord *)calloc(sizeof(gsvrecord),1);	//incl =0-init
	if(!tmpGSV)
	{
		LastErrorGlobal= ERR_MEM_ALLOC;
	   	return GSV_ERROR; 	//
	}
	   //memset(tmpGSV, 0x00, sizeof(gsvrecord));
	   
	   //tmpGSV->in_size= bufsizetmp * FRAME_SIZE;
	   //tmpGSV->in_pos = 0; redundat wg. calloc incl =0-init
   	//tmpGSV->in_count = 0;
#ifdef USE_NEW_ALLOCATION
	tmpGSV->in_buffer= new unsigned char[IN_OWNBUFSIZE];	//thread verwendet in_buffer als Zwischenspeicher f. Daten vom GSV
#else
   	tmpGSV->in_buffer = (unsigned char *)malloc(IN_OWNBUFSIZE);
#endif
	if(tmpGSV->in_buffer==NULL)
   	{ 
		LastErrorGlobal= ERR_MEM_ALLOC;
		ABORT_ACTIVATE; }
   	//tmpGSV->in_missing = 0;
   	tmpGSV->out_size= bufsizetmp; // * sizeof(long);
   	for(i=0;i<CHAN_NO;i++)
   	{
   		//tmpGSV->out_count[i]=0;
#ifdef USE_NEW_ALLOCATION
		tmpGSV->out_buffer[i]= new unsigned long[tmpGSV->out_size * sizeof(long)];
#else
   		tmpGSV->out_buffer[i]= (unsigned long*)malloc(tmpGSV->out_size * sizeof(long));
#endif
   		if(!tmpGSV->out_buffer[i])
   		{
			LastErrorGlobal= ERR_MEM_ALLOC;
			ABORT_ACTIVATE;
		}
		//tmpGSV->out_put[i]=0; tmpGSV->out_get[i]=0;
   	}
	tmpGSV->Param_in_buf= (unsigned char*)malloc(PARAM_INBUF_SIZE);	//buffer fuer Read-Parameter
	tmpGSV->Param_in_missing=0;	//wichtig (eig. red. wg calloc)
#ifdef _DEBUG
	if(ComNo ==0)	//COM0: GSV4 simulieren
	{
		initGSVparam();
		tmpGSV->hcom= NULL;	//simulationsbetrieb: hcom ungueltig
	}
	else
	{
#endif
	//sprintf(portstr,"\\\\.\\COM%i",ComNo); //s. http://msdn2.microsoft.com/en-us/library/aa363858.aspx
	sprintf_s(portstr,16,"\\\\.\\COM%i",ComNo);
	tmpGSV->hcom=CreateFile(portstr,GENERIC_READ | GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);	   
	if(tmpGSV->hcom==INVALID_HANDLE_VALUE)
	{
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x10000000;
#else
		LastErrorGlobal= GetLastError();
#endif
	   ABORT_ACTIVATE;
	}	
#ifdef SLEEP_IN_THREAD
	Timeout.ReadIntervalTimeout= MAXDWORD; //100; http://msdn.microsoft.com/en-us/library/aa363190%28VS.85%29.aspx:
#else
	Timeout.ReadIntervalTimeout= 0;	//ohne SLEEP_IN_THREAD: Lese-Thread-Verzoegerung durch "ewiges Warten" in ReadFile-Funktion
#endif
	/*A value of MAXDWORD, combined with zero values for both the ReadTotalTimeoutConstant and ReadTotalTimeoutMultiplier members,
	specifies that the read operation is to return immediately with the bytes that have already been received,
	even if no bytes have been received. Um Thread nicht zu verzoegern - nur er liest direkt per ReadFile.*/
	Timeout.ReadTotalTimeoutConstant=0; //1000;
	Timeout.ReadTotalTimeoutMultiplier=0; //100;
	Timeout.WriteTotalTimeoutConstant= WRITE_TIMEOUT_CONSTANT; //100;
	Timeout.WriteTotalTimeoutMultiplier= WRITE_TIMEOUT_MULTIPLIER; //2;
	
	if(!SetCommTimeouts(tmpGSV->hcom,&Timeout))
	{
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x20000000;
#else
		LastErrorGlobal= GetLastError();
#endif
		ABORT_ACTIVATE;
	}
	if(!GetCommState(tmpGSV->hcom,&dcb))
	{
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x30000000;
#else
		LastErrorGlobal= GetLastError();
#endif
		ABORT_ACTIVATE;
	}	
	dcb.BaudRate = Bitrate;
	dcb.DCBlength=sizeof(dcb);
	 dcb.fBinary = TRUE;
	   dcb.fParity = FALSE;
	   dcb.fOutxCtsFlow = flags & ACTEX_FLAG_HANDSHAKE ? TRUE : FALSE;
	   dcb.fOutxDsrFlow = FALSE;
	   dcb.fDtrControl = flags & ACTEX_FLAG_HANDSHAKE ? DTR_CONTROL_ENABLE : DTR_CONTROL_DISABLE;
	   dcb.fDsrSensitivity = FALSE;
	   dcb.fTXContinueOnXoff = FALSE;
	   dcb.fOutX = FALSE;
	   dcb.fInX = FALSE;
	   dcb.fErrorChar = FALSE;
	   dcb.fNull = FALSE;
	   dcb.fRtsControl = flags & ACTEX_FLAG_HANDSHAKE ? RTS_CONTROL_HANDSHAKE : RTS_CONTROL_ENABLE; //war RTS_CONTROL_DISABLE;
	   dcb.fAbortOnError = FALSE;
	   dcb.ByteSize = 8; //CHARACTER_SIZE;
	   dcb.Parity = NOPARITY;
	   dcb.StopBits = ONESTOPBIT;

	
	if(!SetCommState(tmpGSV->hcom,&dcb))
	{
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x40000000;
#else
		LastErrorGlobal= GetLastError();
#endif
		ABORT_ACTIVATE;
	}
	if(!SetupComm(tmpGSV->hcom, IN_BUFSIZE,OUT_BUFSIZE))
	{
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x50000000;
#else
		LastErrorGlobal= GetLastError();
#endif
		ABORT_ACTIVATE;
	}
#ifdef _DEBUG
	}
#endif
	tmpGSV->terminate = FALSE;
   	tmpGSV->clear = FALSE;	
	/*thread-init war _beginthread(gsv_data_pump, STACK_SIZE, &gsvs[ComNo])*/
	tmpGSV->thread = (HANDLE)_beginthreadex(NULL,STACK_SIZE, &gsv_data_pump, (gsvrecord*)&gsvs[ComNo], 0, &threadID); //tmpGSV);
	   if (!tmpGSV->thread) // == (unsigned long)-1)
	   {
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x60000000;
#else
		LastErrorGlobal= GetLastError();
#endif
	      ABORT_ACTIVATE;
	   }
#ifdef DUPLICATE_THREAD_HANDLE
	   /* 2. Handle herstellen, mit dem ersten arbeitet die RTL */
	   if (!DuplicateHandle(GetCurrentProcess(), (HANDLE)tmpGSV->thread,
	                        GetCurrentProcess(), &tmpGSV->thread_h,
	                        0, FALSE, DUPLICATE_SAME_ACCESS))
	   {
#ifdef _DEBUG
			LastErrorGlobal= GetLastError()|0x70000000;
#else
		LastErrorGlobal= GetLastError();
#endif
	      tmpGSV->thread_h = NULL;
	      ABORT_ACTIVATE;
	   }
#endif
	tmpGSV->Bitrate= Bitrate;
	tmpGSV->ComNr= ComNo;
		//nu erstmal alles ok: gsv in array eintragen
	gsvs[ComNo] = *tmpGSV;
	gsvs[ComNo].ownPtr= &gsvs[ComNo]; //tmpGSV;	
	gsvs[ComNo].io_mutex =i_mutex;
	gsvs[ComNo].Prd_mutex= rd_mutex;
	gsvs[ComNo].Prd_event= myevent;
	gsvs[ComNo].Clr_event= clrevent;
	/* Dann alle geschtzten Bereiche verlassen */
   	ReleaseMutex(i_mutex);
	ReleaseMutex(rd_mutex);
	if(flags & ACTEX_FLAG_WAIT_EXTENDED)
		wtime= WAIT_ACTIVATE * WAIT_ACTIVATE_FACT;
	else
		wtime= WAIT_ACTIVATE;
   	Sleep(wtime);
	  /* Test auf Kommunikationsbereitschaft */
#ifdef _DEBUG
	if(ComNo !=0)
	{
#endif
	   if (flags & ACTEX_FLAG_HANDSHAKE)
	   {
		  DWORD mst = 0U, wtt = GetTickCount() + TIMEOUT_GSV_INIT;

		  do
		  {
			 if (!GetCommModemStatus(tmpGSV->hcom, &mst))
			 {
				mst = 0U;
				break;
			 }
			 else if (mst & MS_CTS_ON)
				 break;

			 short_delay(TIMEOUT_POLLFLOW);

		  } while (GetTickCount() < wtt);

		  if ((mst & MS_CTS_ON) == 0U)
		  {
			 //ABORT_ACTIVATE;
			  LastErrorGlobal= ERR_COM_GEN_FAILURE;
			  ReleaseGSV(ComNo);
			  return GSV_ERROR;
		  }
	   }
	   if(flags & ACTEX_FLAG_STOP_TX)
	   {
			if(GSV4stopTX(ComNo)==GSV_ERROR)
			{
				LastErrorGlobal= gsvs[ComNo].LastError; //LastError retten
				ReleaseGSV(ComNo);
				return GSV_ERROR;
			}
			if(flags & ACTEX_FLAG_WAIT_EXTENDED)
				Sleep(WAIT_AFTER_STOPTX);
	   }
		else
			gsvs[ComNo].GSVtxOn=true;	//Annehmen, staendige Datenuebertrgung sei an
#ifdef _DEBUG
	}
#endif
	gsvs[ComNo].LastError =0;
	LastErrorGlobal=0;

	/*ERstzer Schnittstellen Schreib- und Lesezugriff*/

	if(flags & ACTEX_FLAG_WAIT_EXTENDED)
	{
	
		for(i=0;i<TRIALS_GET_CMD;i++)
		{
			mode= GSV4getMode(ComNo);
			if(mode!=GSV_ERROR)
				break;
		}
		if(mode==GSV_ERROR)
		{
			LastErrorGlobal= gsvs[ComNo].LastError;	//LastError retten
#ifndef DEBUG_NO_HW_ACCESS
			GSV4release(ComNo);	//kein GSV4 gefunden
			return GSV_ERROR;
#endif
		}
	}
	else		
	{
		if((mode=GSV4getMode(ComNo))==GSV_ERROR)
		{
			LastErrorGlobal= gsvs[ComNo].LastError;	//wird innerhalb der Fkt gesetzt
#ifndef DEBUG_NO_HW_ACCESS
			GSV4release(ComNo);	//kein GSV4 gefunden
			//LastErrorGlobal= ERR_NO_GSV4_FOUND;	//
			return GSV_ERROR;
#endif
		}
	}
	if(mode==0)
	{
		GSV4setMode(ComNo,1,"berlin");
		Sleep(100);
	}
	ret= GSV4getTXmode(ComNo);
	if(ret==GSV_ERROR)
	{
		if(gsvs[ComNo].LastError != ERR_NO_GSV_ANSWER)	//ganz alte FW kennt kein GetTXmode: kein Error
		{
			LastErrorGlobal= gsvs[ComNo].LastError;	//wird innerhalb der Fkt gesetzt
			GSV4release(ComNo);	//kein GSV4 gefunden
			//LastErrorGlobal= ERR_NO_GSV4_FOUND;	//
			return GSV_ERROR;
		}
	}
	else
	{
		if(ret & 0x02)	//Bit1: aktueller TX-state
			gsvs[ComNo].GSVtxOn=true;
		else
			gsvs[ComNo].GSVtxOn=false;
	}
	ret= GSV4firmwareVersion(ComNo);
	if(ret == GSV_ERROR)
		gsvs[ComNo].FWversion= 0;
	else
		gsvs[ComNo].FWversion= ret;
//#endif
	//LastErrorGlobal=0;
	LastErrorIndex =0;
   	return GSV_OK;
}

int CALLTYPE GSV4getLastError(int ComNo)
{
	int val;
	if((LastErrorGlobal && LastErrorIndex==ComNo) || gsvs[ComNo].ownPtr==NULL)	//Activate-Error: hoechte "prio" oder GSV nicht (mehr) vorhanden
	{
		val= LastErrorGlobal;
		LastErrorGlobal =0; //ausserdem nur noch in ActExt gesetzt
	}
	else if(gsvs[ComNo].error)	//Thread-Error: Zweithoechste prio
	{
		val= gsvs[ComNo].error;
#ifdef CLR_THREADERR_ON_GETLASTERR
		//GSV4clearDLLbuffer(ComNo);	//soll Thread-Error loeschen
		if(WaitForSingleObject(gsvs[ComNo].io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
		{
			gsvs[ComNo].error = 0;
			ReleaseMutex(gsvs[ComNo].io_mutex);
		}
#endif
	}
	else	//LastError-Member lesen
	{
		val= gsvs[ComNo].LastError;
		gsvs[ComNo].LastError= 0; //und loeschen
	}
	return val;
}

int CALLTYPE GSV4clearDLLbuffer(int ComNo)
{
	DWORD err=GSV_OK, wtr, wtrCnt;
	int i, res=0;

	CHECK_COMNO;

	gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; //(gsvrecord *) redundant?

	if(WaitForSingleObject(tmp->io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		 /* Datenpuffer lschen */
		for(i=0;i<CHAN_NO;i++)
		{
		   tmp->out_count[i] = 0;
		   tmp->out_put[i] = 0;
		   tmp->out_get[i] = 0;
		}
	   /* Clear-Buffer Anforderung signalisieren */
	   tmp->clear = TRUE;

	   /* evtl. Lesevorgang abbrechen */
	   PurgeComm(tmp->hcom, PURGE_RXABORT | PURGE_RXCLEAR);

	   /* geschtzten Daten-Lese-Bereich verlassen, */
	   /* um "Hintergrund"-Thread Bewegungsfreiheit zu geben */
	   ReleaseMutex(tmp->io_mutex);
	   wtrCnt=PURGE_LOOP_MAX; //neu ver 1.15: sicherer wg. PurgeComm Problem bei einigen Treibern wie usbser.sys
	   do
	   {
		  /* Warten auf Quittierung */
		  wtr = WaitForSingleObject(tmp->Clr_event, TIMEOUT_PURGE);

		  /* Falls Timeout: nochmal Einlesen abbrechen und weiterwarten */
		  if (wtr == WAIT_TIMEOUT)
			 res = PurgeComm(tmp->hcom, PURGE_RXABORT);
		wtrCnt--;
		  err = res ? ERROR_SUCCESS : GetLastError();

	   } while (wtr == WAIT_TIMEOUT && wtrCnt>0);

	   if(WaitForSingleObject(tmp->Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	   {
			tmp->Param_in_count=0;	//Parameter-buffer auch zuruecksetzen
			tmp->Param_in_missing=0;
			ReleaseMutex(tmp->Prd_mutex);
	   }
	   else
	   {
		   tmp->LastError= ERR_MUTEXFAILED;	//LastErrorGlobal=
		   err= GSV_ERROR;
	   }
	}
	else
	{
	   tmp->LastError= ERR_MUTEXFAILED;
	   err= GSV_ERROR;
	}
	if(res==ERROR_SUCCESS && err==GSV_OK && wtr !=WAIT_FAILED)
		return GSV_OK;
	else
		return GSV_ERROR;
}

int CALLTYPE GSV4received(int ComNo, int Chan)
{
	int res, i, Itmp;

	CHECK_COMNO;
	//CHECK_CHAN_ALL;
	if(Chan<0 || Chan>(CHAN_NO+1))
		return GSV_ERROR;

	if(WaitForSingleObject(gsvs[ComNo].io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		if(Chan>CHAN_NO)
		{
			res= 0;	//Chan=5: hoechsten Bufferfuellstand suchen
			for(i=0;i<CHAN_NO;i++)
			{
				Itmp= gsvs[ComNo].out_count[i];
				if(Itmp >= res)
					res= Itmp;
			}
		}
		else if(Chan==0)
		{
			res= gsvs[ComNo].out_size +1;	//Chan=0: niedrigsten Bufferfuellstand suchen
			for(i=0;i<CHAN_NO;i++)
			{
				Itmp= gsvs[ComNo].out_count[i];
				if(Itmp <= res)
					res= Itmp;
			}
		}
		else
			res= gsvs[ComNo].out_count[Chan-1];
		ReleaseMutex(gsvs[ComNo].io_mutex);
	}
	else
	{
		gsvs[ComNo].LastError= ERR_MUTEXFAILED;
		res=GSV_ERROR;
	}
	return res;
}

int CALLTYPE GSV4readAll(int ComNo, double* out0, double* out1, double* out2, double* out3)
{
	int i,result = GSV_TRUE; //,err;

	CHECK_COMNO;
#ifdef CHECK_POINTER_ARGS	//NEVER EVER USE THIS...!!
	i= sizeof(double);
	if(IsBadWritePtr((void*)out0,i)||IsBadWritePtr((void*)out1,i)||IsBadWritePtr((void*)out2,i)||IsBadWritePtr((void*)out3,i))
		RET_WRONG_PARAMETER;
#endif
   gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; //(gsvrecord *) redundant?

	if(WaitForSingleObject(tmp->io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		//gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; //(gsvrecord *) redundant?
		for(i=0;i<CHAN_NO;i++)
		{
			if(!tmp->out_count[i])	//haben alle DAten?
				result=GSV_OK;			//nein: result=0
		}
		if(result && !tmp->error)
		{
			*out0= CALC_GSV_DATA(*(tmp->out_buffer[0] + tmp->out_get[0])); //CalcGSVdata
#ifndef TEST_GSV3
			*out1= CALC_GSV_DATA(*(tmp->out_buffer[1] + tmp->out_get[1]));
			*out2= CALC_GSV_DATA(*(tmp->out_buffer[2] + tmp->out_get[2]));
			*out3= CALC_GSV_DATA(*(tmp->out_buffer[3] + tmp->out_get[3]));
#endif
			for(i=0;i<CHAN_NO;i++)
			{
				 tmp->out_get[i] = (tmp->out_get[i] + 1) % tmp->out_size;
				tmp->out_count[i]--;
			}

		}
		ReleaseMutex(tmp->io_mutex);
	}
	else
	{
	   tmp->LastError= ERR_MUTEXFAILED;
	   result= GSV_ERROR;
	}
	if(tmp->error)
		result=GSV_ERROR;
	return result;
  }

int CALLTYPE GSV4read(int ComNo, int Chan, double* out)
{
	int result = GSV_TRUE,ix; //,err;

	CHECK_COMNO;
	CHECK_CHAN;
#ifdef CHECK_POINTER_ARGS 	//NEVER EVER USE THIS...!!
	if(IsBadWritePtr((void*)out,sizeof(double)))
		RET_WRONG_PARAMETER;
#endif
   gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; //(gsvrecord *) redundant?
   ix= Chan-1;

	if(WaitForSingleObject(tmp->io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		//gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; //(gsvrecord *) redundant?
		if(!tmp->out_count[ix])	//hat dieser Kanal DAten?
			result=GSV_OK;			//nein: result=0
		if(result && !tmp->error)
		{
			*out= CALC_GSV_DATA(*(tmp->out_buffer[ix] + tmp->out_get[ix]));
			tmp->out_get[ix] = (tmp->out_get[ix] + 1) % tmp->out_size;
			tmp->out_count[ix]--;

		}
		ReleaseMutex(tmp->io_mutex);
	}
	else
	{
	   tmp->LastError= ERR_MUTEXFAILED;
	   result= GSV_ERROR;
	}
	if(tmp->error)
		result=GSV_ERROR;
	return result;
}

int CALLTYPE GSV4readMultiple(int ComNo, int Chan, double *out, int count, int* valsread)
{
	int i,n,result, Valnum;
	unsigned long  Ltmp;

	CHECK_COMNO;
	CHECK_CHAN_ALL;
	if(count < 1)
		RET_WRONG_PARAMETER;
	if(Chan==0 && (count % 4))	//Wenn alle Kanaele (Chan=0): count muss durch 4 teilbar sein
		RET_WRONG_PARAMETER;
#ifdef CHECK_POINTER_ARGS 	//NEVER EVER USE THIS...!!
	if(!Chan)	//Chan=0:Array muss alle Kanaele aufnehmen koennen 
	{
		if(IsBadWritePtr((void*)out, CHAN_NO*count * sizeof(double)) || IsBadWritePtr((void*)valsread,sizeof(int)))
			RET_WRONG_PARAMETER;
	}
	else
	{
		if(IsBadWritePtr((void*)out, count * sizeof(double)) || IsBadWritePtr((void*)valsread,sizeof(int)))
			RET_WRONG_PARAMETER;
	}
	/*if(!AfxIsValidAddress ((void*)out, count * sizeof(double), TRUE))
		RET_WRONG_PARAMETER; siehe http://msdn.microsoft.com/en-us/library/aa366716(VS.85).aspx */
#endif
	

	gsvrecord *tmp = (gsvrecord *)gsvs[ComNo].ownPtr; 

	if(WaitForSingleObject(tmp->io_mutex, MUTEX_MAX_WAITTIME)==WAIT_OBJECT_0) //if(EnterGSVreadMutex(ComNo))
	{
		if(Chan)
			Valnum= tmp->out_count[Chan-1];
		else
		{
			Valnum= tmp->out_size +1;	//minimalen Bufferfuellstand suchen
			for(i=0;i<CHAN_NO;i++)
			{
				Ltmp= tmp->out_count[i];
				if(Ltmp <= (unsigned long)Valnum)
					Valnum= (int)Ltmp;
			}
		}
		if(Valnum==0)
		{
			ReleaseMutex(tmp->io_mutex);
			*valsread=0;
			return 0;	//keine Werte in Buffer(n)
		}
		if(Chan)
		{
			n= Chan-1;
			if(Valnum > count)
				Valnum= count;
			for(i=0;i<Valnum;i++)
			{
				*out++ = CALC_GSV_DATA(*(tmp->out_buffer[n] + tmp->out_get[n]));
				tmp->out_get[n] = (tmp->out_get[n] + 1) % tmp->out_size;
				//tmp->out_count[n]--;
			}
			tmp->out_count[n]-= Valnum;
			*valsread = (int)Valnum;
		}
		else	//Alle 4 Kanaele lesen
		{
			if(Valnum > (count/4))
				Valnum= count/4;
			for(i=0;i<Valnum;i++)
			{
				for(n=0;n<CHAN_NO;n++)	//Sortierung out: K1 in Ix*4, K2 in (Ix*4)+1, K3 in (Ix*4)+2, K4 in (Ix*4)+3
				{
					*out++ = CALC_GSV_DATA(*(tmp->out_buffer[n] + tmp->out_get[n]));
					tmp->out_get[n] = (tmp->out_get[n] + 1) % tmp->out_size;
					//tmp->out_count[n]--;
				}
			}
			for(n=0;n<CHAN_NO;n++)
				tmp->out_count[n]-= Valnum;
			*valsread= (int)(Valnum *4);
		}
		ReleaseMutex(tmp->io_mutex);
		result= GSV_TRUE;
	}
	else
	{
	   tmp->LastError= ERR_MUTEXFAILED;
	   result= GSV_ERROR;
	}
	if(tmp->error)
		result=GSV_ERROR;
	return result;
}

int StartTX(int ComNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	
	CHECK_COMNO;
	txbuf[0]= 0x24;
	if(!WriteFile(gsvs[ComNo].hcom, txbuf, 1, &Byteswritten, NULL))
	{	
		gsvs[ComNo].LastError= GetLastError() | OWN_ERR_MASK;
		return GSV_ERROR; 
	}
	if(Byteswritten != 1)
	{
		gsvs[ComNo].LastError= ERR_BYTES_WRITTEN;
		return GSV_ERROR;
	}
	return GSV_OK;
}
int CALLTYPE GSV4startTX(int ComNo)
{
	int ret= GSV_OK;
#ifdef _DEBUG
	if(ComNo>0)
#endif
		ret= StartTX(ComNo);

	if(ret==GSV_OK)
	{
		gsvs[ComNo].GSVtxOn= true;
		return GSV_OK;
	}
	else
		return GSV_ERROR;
}

int StopTX(int ComNo)
{
	char txbuf[2];
	DWORD Byteswritten;

	CHECK_COMNO;
	txbuf[0]= 0x23;
	if(!WriteFile(gsvs[ComNo].hcom, txbuf, 1, &Byteswritten, NULL))
	{	
		gsvs[ComNo].LastError= GetLastError() | OWN_ERR_MASK;
		return GSV_ERROR; 
	}
	if(Byteswritten != 1)
	{
		gsvs[ComNo].LastError= ERR_BYTES_WRITTEN;
		return GSV_ERROR;
	}
	return GSV_OK;
}
int CALLTYPE GSV4stopTX(int ComNo)
{
	int ret= GSV_OK;
#ifdef _DEBUG
	if(ComNo>0)
#endif
		ret= StopTX(ComNo);

	if(ret==GSV_OK)
	{
		gsvs[ComNo].GSVtxOn= false;
		return GSV_OK;
	}
	else
		return GSV_ERROR;
}

int CALLTYPE GSV4release(int ComNo)
{
	//unsigned int wait=0;

	CHECK_COMNO;

	ReleaseGSV(ComNo);
	return GSV_OK;
}

int CALLTYPE GSV4setZero(int ComNo, int Chan)	//Chan=0: Alle Kanaele
{
	char txbuf[2];
	DWORD Byteswritten;
	int res,i;
	
	CHECK_COMNO;
	CHECK_CHAN_ALL;
#ifdef _DEBUG
	if(ComNo==0)
		return GSV_OK;
#endif
#ifdef STOPTX_ON_SET_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x0C;
	res=GSV_OK;
	if(!Chan)
	{
		for(i=1;i<=CHAN_NO;i++)
		{
			txbuf[1]= (char)i;
			WRITE_BYTES_CHK_SUCC(2);
		}
	}
	else
	{
		txbuf[1]= (char)Chan;
		WRITE_BYTES_CHK_SUCC(2);
	}
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4saveAll(int ComNo, int DataNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
	if(DataNo<1 || DataNo>3)
		RET_WRONG_PARAMETER;
#ifdef _DEBUG
	if(ComNo==0)
		return GSV_OK;
#endif
#ifdef STOPTX_ON_SET_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x09; txbuf[1]= DataNo;
	WRITE_BYTES_CHK_SUCC(2);
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4getAll(int ComNo, int DataNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
	if(DataNo<1 || DataNo>3)
		RET_WRONG_PARAMETER;
#ifdef _DEBUG
	if(ComNo==0)
		return GSV_OK;
#endif
#ifdef STOPTX_ON_SET_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x0A; txbuf[1]= DataNo;
	WRITE_BYTES_CHK_SUCC(2);
	Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4writeFreq(int ComNo, double Freq)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_OK,i, Ix;
	double Maxfreq; //, tstFreq;
	unsigned char Fcode=0;
	double DataRateTable[]=
	{
	1/(86400.0), 1/(43200.0),1/(21600.0),1/(3600.0),1/(1800.0),	1/(900.0),1/(600.0),1/(300.0),0.02,
	0.03,0.1,0.2,0.5,(2.5)/4,1.25,2.5,3.75,6.25,7.5,12.5,15,25,125,250,500,937.5,1875,3750,7500
	};
	unsigned char DataRateCode[]=
	{
		0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,
		0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF
	};
	
	CHECK_COMNO;

	if(gsvs[ComNo].FWversion >= DATARATE_NEWMAX_VERMIN)
		Maxfreq= DATARATE_MAX_NEW;
	else Maxfreq= DATARATE_MAX_OLD;
	if(Freq<DBL_EPSILON || Freq>Maxfreq)
		RET_WRONG_PARAMETER;
	Maxfreq= (gsvs[ComNo].Bitrate / (FRAME_SIZE*10)) * MAX_BUS_LOAD;	//auf Maximum wg. Busleitungsmax testen
	if(Freq>Maxfreq)
		RET_WRONG_PARAMETER;

	for(i=0;i<(DATARATE_NUM-1);i++)	//vorhandene Frequenz suchen
	{
#ifdef SETFREQ_DIRECTINTERVAL
		if(i==0 && Freq<=DataRateTable[0])	//gewuenschte Freq unterhalb der niedrigsten vorhandenen Freq?
		{
			Fcode= DataRateCode[0];		//ja: unterste vorhandene nehmen
			Ix=0;
			break;
		}
		else if(Freq> DataRateTable[i] && Freq <=DataRateTable[i+1])
		{		//wenn gewuenschte Freq innerhalb eines Intervalls vorhandener Freqenzen:
			Fcode= DataRateCode[i+1];	//obere Inervallgenze nehmen,dh naechsthoehere Freq
			Ix= i+1;
			break;
		}
#else
		tstFreq= (DataRateTable[i]+DataRateTable[i+1])/2; //Interpolationsintervall erstellen
		if(Freq <= tstFreq)	//ggf. die jeweils niedrigere vorhandene Freq nehmen
		{
			Fcode= DataRateCode[i];
			Ix=i;
			break;
		}
#endif
	}
	if(!Fcode)
	{
		if(i==(DATARATE_NUM-2))
		{
			Fcode= DataRateCode[DATARATE_NUM-1];	// Max setzen
			Ix= DATARATE_NUM-1;
		}
		else
			return GSV_ERROR;	//nix gefunden.
	}
	if(DataRateTable[Ix] > Maxfreq)	//gefundene Freq zu hoch?
		Fcode= DataRateCode[Ix-1];	//ja: naechstniedrigere nehmen

#ifdef _DEBUG
	if(ComNo==0)
	{
		GSVsim.drcode= Fcode;
		GSVsim.period= ((int)(1000 / DataRateTable[Ix])) +1; //Achtung: Thread GSVsimTimer!!!
		return GSV_OK;
	}
#endif
#ifdef STOPTX_ON_WRITE_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x12; txbuf[1]= Fcode;
	WRITE_BYTES_CHK_SUCC(2);
	//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_WRITE_COMMAND
	START_TX
#endif
	return res;
}

double CALLTYPE GSV4readFreq(int ComNo)
{
	double Freq=0;
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE,i; //=GSV_OK;
	char Fcode=0;
	unsigned int Waittime =0;
	BOOL tst;
	double DataRateTable[]=
	{
	1/(86400.0), 1/(43200.0),1/(21600.0),1/(3600.0),1/(1800.0),	1/(900.0),1/(600.0),1/(300.0),0.02,
	0.03,0.1,0.2,0.5,(2.5)/4,1.25,2.5,3.75,6.25,7.5,12.5,15,25,125,250,500,937.5,1875,3750,7500
	};
	char DataRateCode[]=
	{
		0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,
		0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF
	};

	CHECK_COMNO;
#ifdef _DEBUG
	if(ComNo==0)
		return (GSVsim.period > 1)? 1000 / ((double)(GSVsim.period-1)) : GSV_ERROR;
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x16;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		//gsvs[ComNo].Param_in_pos=0;
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE+1; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
//#ifdef _DEBUG
		tst= ResetEvent(gsvs[ComNo].Prd_event);
//#endif
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
			
		if(res==GSV_OK) // && Waittime < PARAMRESPONSE_TIMEOUT)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			Fcode= gsvs[ComNo].Param_in_buf[8];	//Data beginnt ab [8] innerhalb response-frame
			
			res= GSV_ERROR;
			for(i=0;i<DATARATE_NUM;i++)
			{
				if(Fcode == DataRateCode[i])
				{
					Freq= DataRateTable[i];
					res= GSV_OK;
					break;
				}
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK) // && Freq>0)
		return Freq;
	else
		return GSV_ERROR;
}

int CALLTYPE MeGSV4writeSerialNo(int ComNo, char* SerNo)
{
	char txbuf[9], serial[20];
	DWORD Byteswritten;
	int res=GSV_OK,i; //=GSV_OK;
	
	CHECK_COMNO;
	/*len= strlen(SerNo);
	if(len >19)
		return GSV_ERROR;
	strcpy(serial, SerNo);
	if(len<8)
	{
		for(i=len;i<8;i++)
			serial[i]= '0';	//String zu kurz: Mit 0 auffuellen
		serial[8]=0;
	}*/
	if(strlen(SerNo) !=8)
		RET_WRONG_PARAMETER
	if(strcpy_s(serial, sizeof(serial), SerNo) !=0)
		RET_WRONG_PARAMETER
	txbuf[0]= 0x1E;
	for(i=1;i<9;i++)
		txbuf[i]=serial[i-1];

#ifdef STOPTX_ON_WRITE_COMMAND
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(9);
	//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_WRITE_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4readSerialNo(int ComNo, char* SerNo)
{
	char txbuf[2], serial[9];
	DWORD Byteswritten, err;
	int res,i;
	
	CHECK_COMNO;
#ifdef CHECK_POINTER_ARGS
	if(IsBadWritePtr((void*)SerNo,9))
		RET_WRONG_PARAMETER;
#endif
#ifdef _DEBUG
	if(ComNo==0)
	{
		strcpy(SerNo,"12345678");
		return GSV_OK;
	}
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif

	txbuf[0]= 0x1F;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED)
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +8; //Antwort-data= 8 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if((err=WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT))==WAIT_OBJECT_0)
			res= GSV_OK;
		else
		{
			gsvs[ComNo].LastError= ERR_NO_GSV_ANSWER;
#ifdef _DEBUG
			res=err;
#else
			res= GSV_ERROR;
#endif
		}
		RES_CHK_PARAM_COUNT(8);
		
		if(res==GSV_OK) // && Waittime < PARAMRESPONSE_TIMEOUT)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			for(i=0;i<8;i++)
			{
				serial[i]= gsvs[ComNo].Param_in_buf[i+8];
			}
			serial[8]=0;
			if(strcpy_s(SerNo, 9, &serial[0]) != 0)
				RET_WRONG_PARAMETER
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	return res;
}
	
int CALLTYPE GSV4writeThreshold(int ComNo, int ThresNo, double ThresOn, double ThresOff)
{
	unsigned char txbuf[5];
	DWORD Byteswritten;
	int res=GSV_OK,i;
	signed long lthOn, lthOff;
	
	CHECK_COMNO;
	if(ThresNo<0 || ThresNo>THRES_NO_MAX) //W: 0..8
		RET_WRONG_PARAMETER;

	lthOn= sl_round(ThresOn/BIPOLAR_SCALE); // + BIPOLAR_ZERO;
	lthOff= sl_round(ThresOff/BIPOLAR_SCALE); // + BIPOLAR_ZERO;
	//if(lthOn>0 && lthOn<=MAX16BIT && lthOff>0 && lthOff<=MAX16BIT && lthOn >= lthOff)	//letzte Bed. noetig??
	if(lthOn >= -32768 && lthOn<=32767 && lthOff >= -32768 && lthOff<=32767 && lthOn >= lthOff)
	{
		txbuf[0]= 0x20;
#ifdef STOPTX_ON_WRITE_COMMAND
		STOP_TX
#endif
		if(!ThresNo)	//ThresNo=0: Alle 8 Schwellwerte gleich setzen
		{
			for(i=1;i<=THRES_NO_MAX;i++)
			{
				if(res != GSV_ERROR)
				{
					txbuf[1]= (unsigned char)((i*2)-1);
					txbuf[2]= (unsigned char)((lthOn >> 8) & 0x00FF);
					txbuf[3]= (unsigned char)(lthOn & 0x00FF);
					WRITE_BYTES_CHK_SUCC(4);
					Sleep(100);		//mit Thomas abklaeren!
				}
				if(res != GSV_ERROR)
				{
					txbuf[1]= (unsigned char)(i*2);
					txbuf[2]= (unsigned char)((lthOff >> 8) & 0x00FF);
					txbuf[3]= (unsigned char)(lthOff & 0x00FF);
					WRITE_BYTES_CHK_SUCC(4);
					Sleep(100);		//mit Thomas abklaeren!
				}
			}
		}
		else
		{
			txbuf[1]= (char)((ThresNo*2)-1);
			txbuf[2]= (char)((lthOn >> 8) & 0x00FF);
			txbuf[3]= (char)(lthOn & 0x00FF);
			WRITE_BYTES_CHK_SUCC(4);
			if(res != GSV_ERROR)
			{
				Sleep(100);		//mit Thomas abklaeren!
				txbuf[1]= (char)(ThresNo*2);
				txbuf[2]= (char)((lthOff >> 8) & 0x00FF);
				txbuf[3]= (char)(lthOff & 0x00FF);
				WRITE_BYTES_CHK_SUCC(4);
			}
		}
#ifdef STOPTX_ON_WRITE_COMMAND
		START_TX
#endif
	}
	else
		RET_WRONG_PARAMETER;
	return res;
}

int CALLTYPE GSV4readThreshold(int ComNo, int ThresNo, double *ThresOn, double *ThresOff)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE;
	unsigned long thOn=0, thOff=0;
	//signed short thOn=0, thOff=0;
	
	CHECK_COMNO;
	if(ThresNo<THRES_NO_MIN || ThresNo>THRES_NO_MAX)
		RET_WRONG_PARAMETER;
#ifdef CHECK_POINTER_ARGS
	if(IsBadWritePtr((void*)thres,sizeof(double)))
		RET_WRONG_PARAMETER;
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x21;
	txbuf[1]= (char)((ThresNo*2)-1);
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +3; //Antwort-data= 3 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(2);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(3);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			if(gsvs[ComNo].Param_in_buf[8] != txbuf[1])	//ValNo muss uebereinstimmen
				res=GSV_ERROR;
			thOn= (gsvs[ComNo].Param_in_buf[9] << 8) & 0xFF00;
			thOn |= (gsvs[ComNo].Param_in_buf[10] & 0x00FF);
		}
	}
	else
		RES_MUTEXFAILED;
	if(res != GSV_ERROR)
	{
		txbuf[1]= (char)(ThresNo*2);
		if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
		{
			gsvs[ComNo].Param_in_count=0;
			gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +3; //Antwort-data= 1 Byte
			ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
			ResetEvent(gsvs[ComNo].Prd_event);
			res= GSV_TRUE;
			WRITE_BYTES_CHK_SUCC(2);
		
			if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
				res= GSV_OK;
			else
				RES_NO_GSVANSWER;

			RES_CHK_PARAM_COUNT(3);
			
			if(res==GSV_OK)
			{
	#ifdef RESPONSEFRAME_DEEPANALYSE
				//to do...
	#endif
				if(gsvs[ComNo].Param_in_buf[8] != txbuf[1])	//ValNo muss uebereinstimmen
					res=GSV_ERROR;
				thOff= (gsvs[ComNo].Param_in_buf[9] << 8) & 0xFF00;
				thOff |= (gsvs[ComNo].Param_in_buf[10] & 0x00FF);
			}
		}
		else
			RES_MUTEXFAILED;
	}
	if(res != GSV_ERROR)
	{
		if(thOn< MAX16BIT && thOff< MAX16BIT)
		{
			*ThresOn= CALC_GSV_DATA((thOn+BIPOLAR_ZERO)&MAX16BIT);
			*ThresOff= CALC_GSV_DATA((thOff+BIPOLAR_ZERO)&MAX16BIT);
		}
		else
		{
			gsvs[ComNo].LastError= ERR_WRONG_ANSWER;	//LastErrorGlobal
			res= GSV_ERROR;
		}
	}
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4setMode(int ComNo, int Mode, char* pw)
{
	char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK, i;
	
	CHECK_COMNO;
	if(Mode<MODUS_MIN || Mode>MODUS_MAX)
		RET_WRONG_PARAMETER;
	if(strlen(pw) != 6)	//Passwort muss genau 6 Zeichen haben
		RET_WRONG_PARAMETER;
#ifdef _DEBUG
	if(ComNo==0)
	{
		GSVsim.mode= Mode;
		return GSV_OK;
	}
#endif
	txbuf[0]= 0x26;
	txbuf[1]= (char)Mode;
	for(i=0;i<6;i++)
		txbuf[i+2]= pw[i];

#ifdef STOPTX_ON_SET_COMMAND
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(8);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4getMode(int ComNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE;
	
	CHECK_COMNO;
#ifdef _DEBUG
	if(ComNo==0)
		return GSVsim.mode;
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x27;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			res= gsvs[ComNo].Param_in_buf[8];
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4firmwareVersion(int ComNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE;
	
	CHECK_COMNO;
#ifdef _DEBUG
	if(ComNo==0)
		return 1;
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x2B;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			res= gsvs[ComNo].Param_in_buf[8];
		}
	}
	else
		res= GSV_ERROR;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4getValue(int ComNo)
{
	char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
	txbuf[0]= 0x3B;
#ifdef _DEBUG
	if(ComNo==0)
		return GSV_OK;
#endif
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(1);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE MeGSV4setScale(int ComNo, int Chan, int gain, long Scale)
{
	unsigned char txbuf[8];
	unsigned long Byteswritten,btoWr;
	int res=GSV_OK;
	long tmp;

	
	CHECK_COMNO;
	CHECK_CHAN;
	if(gain<GAIN_MIN || gain>GAIN_MAX)
		RET_WRONG_PARAMETER;
	tmp= Scale;
	txbuf[0]= 0x88;
	txbuf[1]= (char)Chan;
	txbuf[2]= (char)gain;
	if(gain==5)	//bei 0,1mV/V: Interbner Scale-Faktor hat 32 bit
	{
		txbuf[3]= (tmp >> 24) & 0xFF;
		txbuf[4]= (tmp >> 16) & 0xFF;
		txbuf[5]= (tmp >> 8) & 0xFF;
		txbuf[6]= tmp & 0xFF;
		btoWr= 7;
	}
	else
	{
		txbuf[3]= (tmp >> 16) & 0xFF;	//sonst 24 bit
		txbuf[4]= (tmp >> 8) & 0xFF;
		txbuf[5]= tmp & 0xFF;
		btoWr= 6;
	}
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(btoWr);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE MeGSV4getScale(int ComNo, int Chan, int gain)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE;
	long scal;
	unsigned long ByToRec;
	
	CHECK_COMNO;
	CHECK_CHAN;
	if(gain<GAIN_MIN || gain>GAIN_MAX)
		RET_WRONG_PARAMETER;
	if(gain==5)
		ByToRec= 6;
	else
		ByToRec= 5;
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x89;
	txbuf[1]= (unsigned char)Chan;
	txbuf[2]= (unsigned char)gain;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +ByToRec; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(3);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(ByToRec);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			//res= gsvs[ComNo].Param_in_buf[8];
			if(gsvs[ComNo].Param_in_buf[8]!=txbuf[1] || gsvs[ComNo].Param_in_buf[9]!=txbuf[2]) //Chan und gain muessen uebereinstimmen
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res= GSV_ERROR;
			}
			else
			{
				if(gsvs[ComNo].Param_in_buf[4]==6) //gain==5) len-Prameter auswerten
				{
					scal= (gsvs[ComNo].Param_in_buf[10] << 24) & 0xFF000000;
					scal |= (gsvs[ComNo].Param_in_buf[11] << 16) & 0x00FF0000;
					scal |= (gsvs[ComNo].Param_in_buf[12] << 8) & 0x0000FF00;
					scal |= gsvs[ComNo].Param_in_buf[13] & 0x000000FF;
				}
				else
				{
					scal= (gsvs[ComNo].Param_in_buf[10] << 16) & 0x00FF0000;
					scal |= (gsvs[ComNo].Param_in_buf[11] << 8) & 0x0000FF00;
					scal |= gsvs[ComNo].Param_in_buf[12] & 0x000000FF;
				}
				res= GSV_OK;
			}

		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return scal;
	else
		return res;
}

int CALLTYPE GSV4setBaudSerial(int ComNo, long Bitrate)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_ERROR, i;
	char Bcode;
	char SerBaudCode[]= 	/* Baudratencodierung GSV-4 */
	{
		0x10, 0x20,0x30,0x40,0x50,0x60
	};
	
	CHECK_COMNO;
	for(i=0;i<BAUD_NO;i++)
	{
		if(Bitrate==baud_table[i])
		{
			Bcode= SerBaudCode[i];
			res= GSV_OK;
			break;
		}
	}
	if(res != GSV_OK)
		RET_WRONG_PARAMETER;
	txbuf[0]= 0xB0;
	txbuf[1]= Bcode;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(2);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4getBaudSerial(int ComNo)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE,i;
	unsigned long baud;
	unsigned char Bcode;
	unsigned char SerBaudCode[]= 	/* Baudratencodierung GSV-4 */
	{
		0x10, 0x20,0x30,0x40,0x50,0x60
	};
	
	CHECK_COMNO;
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xB1;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			Bcode= gsvs[ComNo].Param_in_buf[8];
			res=GSV_ERROR;
			for(i=0;i<BAUD_NO;i++)
			{
				if(Bcode==SerBaudCode[i])
				{
					baud= baud_table[i];
					res= GSV_OK;
					break;
				}
			}

		}
		if(res!=GSV_OK)
			gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return baud;
	else
		return res;
}

int CALLTYPE GSV4setGain(int ComNo, int Chan, int gain)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
	CHECK_CHAN;
	if(gain<GAIN_MIN || gain>GAIN_MAX)
		RET_WRONG_PARAMETER;
#ifdef _DEBUG
	if(ComNo==0)
	{
		GSVsim.gain[Chan-1]= gain;
		return GSV_OK;
	}
#endif
	txbuf[0]= 0xB2;
	txbuf[1]= (char)Chan;
	txbuf[2]= (char)gain;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(3);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4getGain(int ComNo, int Chan)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE,i;
	unsigned long gain;
	
	CHECK_COMNO;
	CHECK_CHAN_ALL;
#ifdef _DEBUG
	if(ComNo==0)
	{
		if(Chan)
				gain= (long)GSVsim.gain[Chan-1];
		else
		{
			for(i=0;i<sizeof(long);i++)
				*(((char*)&gain)+(3-i))= GSVsim.gain[Chan-1];
		}
		return gain;
	}
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xB3;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +4; //Antwort-data= 4 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(4);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			if(Chan)
				gain= (long)gsvs[ComNo].Param_in_buf[8+(Chan-1)];
			else
			{
				/*gain= (gsvs[ComNo].Param_in_buf[8] <<24) & 0xFF000000;	//K1: Highest
				gain |= (gsvs[ComNo].Param_in_buf[9] <<16) & 0x00FF0000;
				gain |= (gsvs[ComNo].Param_in_buf[10] <<8) & 0x0000FF00;
				gain |= gsvs[ComNo].Param_in_buf[11] & 0x000000FF;		//..K4: Lowest*/
				for(i=0;i<sizeof(long);i++)
					*(((char*)&gain)+(3-i))= gsvs[ComNo].Param_in_buf[8+i];
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return gain;
	else
		return res;
}

int CALLTYPE GSV4setAnalogueType(int ComNo, int Chan, AinType type) //Chan=0: Alle Kanaele
{
	int i, res=GSV_OK;

	CHECK_CHAN_ALL;
	if(Chan)
		return GSV4setGain(ComNo, Chan, (int)type);
	else
	{
		for(i=1;i<=CHAN_NO;i++)
		{
			if(res != GSV_ERROR)
			{
				res= GSV4setGain(ComNo, i, (int)type);
				Sleep(DELAY_BETWEEN_COMMANDS);
			}
		}
		return res;
	}
}

int CALLTYPE GSV4getAnalogueType(int ComNo, AinType* typCh1, AinType* typCh2, AinType* typCh3, AinType* typCh4)
{
	//long Allgains=GSV_OK;
	union x{ char bVal[4];
			long lVal;
	} X;


	int res;
	//char* ptr;
	
	X.lVal= GSV4getGain(ComNo,0);

	//ptr= ((char*)&Allgains);
	if(X.lVal != GSV_ERROR)
	{/*
		*typCh1= (AinType)((Allgains >> 24) & 0xFF);
		*typCh2= (AinType)((Allgains >> 16) & 0xFF);
		*typCh3= (AinType)((Allgains >> 8) & 0xFF);
		*typCh4= (AinType)(Allgains & 0xFF);

		*typCh1= (AinType)*(((char*)&Allgains)+3);
		*typCh2= (AinType)*(((char*)&Allgains)+2);
		*typCh3= (AinType)*(((char*)&Allgains)+1);
		*typCh4= (AinType)*((char*)&Allgains));*/

		*typCh1= (AinType)X.bVal[3];
		*typCh2= (AinType)X.bVal[2];
		*typCh3= (AinType)X.bVal[1];
		*typCh4= (AinType)X.bVal[0];

		res=GSV_OK;
	}	
	else
		res= GSV_ERROR;
	return res;
}

int CALLTYPE GSV4DispSetNorm(int ComNo, int Chan, double Norm)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	float n;
	char* Bptr;
	
	CHECK_COMNO;
	CHECK_CHAN;
	
	if(Norm>FLT_MAX || (Norm<=FLT_EPSILON && Norm >= -FLT_EPSILON)) //FLT_MIN) Norm =0 verbieten
		RET_WRONG_PARAMETER;				//seit ver. 1.8: Negative norm moeglich, zwecks software-umpolung
#ifdef _DEBUG
	if(ComNo==0)
	{
		GSVsim.norm[Chan-1]= Norm;
		return GSV_OK;
	}
#endif
	txbuf[0]= 0xBA;
	txbuf[1]= (char)Chan;
	n= (float)Norm;
	Bptr= (char*)&n;
	txbuf[2]= *(Bptr+3);	//ok? TESTEN: ok. im GSV Hi-Endian speichern
	txbuf[3]= *(Bptr+2);
	txbuf[4]= *(Bptr+1);
	txbuf[5]= *Bptr;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(6);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

double CALLTYPE GSV4DispGetNorm(int ComNo, int Chan)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE;
	float Ftmp;
	char* Bptr;
	
	CHECK_COMNO;
	CHECK_CHAN;
#ifdef _DEBUG
	if(ComNo==0)
		return GSVsim.norm[Chan-1];
#endif
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xBB;
	txbuf[1]= (char)Chan;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +5; //Antwort-data= 4 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(2);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(5);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			if(gsvs[ComNo].Param_in_buf[8]==txbuf[1])
			{
				Bptr= (char*)&Ftmp;
				*Bptr = gsvs[ComNo].Param_in_buf[12];		//ok? TESTEN: ok
				*(Bptr+1)= gsvs[ComNo].Param_in_buf[11];
				*(Bptr+2)= gsvs[ComNo].Param_in_buf[10];
				*(Bptr+3)= gsvs[ComNo].Param_in_buf[9];
			}
			else
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res=GSV_ERROR;
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return (double)Ftmp;
	else
		return 0; //GSV_ERROR; geaendert v. 1.13
}

/*int CALLTYPE GSV4getDigitalThreshold(int ComNo, int BitNo)	//BitNo=0: alle Bits, sonst: 1..8
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_TRUE, Itmp;
	char Ctmp;
	
	CHECK_COMNO;
	if(BitNo>8 || BitNo<0)
		RET_WRONG_PARAMETER;
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xBC;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			Ctmp= gsvs[ComNo].Param_in_buf[8];
			if(BitNo)
			{
				Itmp= GetBitValue((long)Ctmp, BitNo-1);
				if(Itmp==GSV_ERROR)
				{
					LastErrorGlobal= ERR_WRONG_ANSWER;
					res=GSV_ERROR;
				}
			}
			else
				Itmp= (int)Ctmp;
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return Itmp;
	else
		return res;
}

int CALLTYPE GSV4setDigitalThreshold(int ComNo, int BitNo, int value)	//BitNo=0: alle Bits, sonst: 1..8
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_OK, getVal, msk;
	
	CHECK_COMNO;
	if(BitNo>8 || BitNo<0)
		RET_WRONG_PARAMETER;
	
	txbuf[0]= 0xB6;
	if(BitNo)
	{				// to do: STOP_TX-Saveval!!
		getVal= GSV4getDigitalThreshold(ComNo, 0);
		if(getVal==GSV_ERROR)
			res=GSV_ERROR;
		else
		{
			msk= MakeBitMask(value, BitNo-1);
			if(value)
				txbuf[1]= (char)(getVal | msk);
			else
				txbuf[1]= (char)(getVal & msk);
		}
	}
	else
		txbuf[1]= (char)value;
 
	if(res==GSV_OK)
	{
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
		STOP_TX
#endif
		WRITE_BYTES_CHK_SUCC(2);
			//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
		START_TX
#endif
	}
	return res;
}*/

int CALLTYPE GSV4getDigitalIOtype(int ComNo, int DigIO_No)	//BitNo=0: alle Bits, sonst: 1..8
{
	unsigned char txbuf[4];
	DWORD Byteswritten;
	int res=GSV_TRUE, Itmp;
	char Ctmp;
	
	CHECK_COMNO;
	CHECK_FW_VERSION(FW_VER_MIN_DIO);	//FW-ver min: 0x08??
	if(gsvs[ComNo].FWversion < FW_VER_MIN_DIO_EXT)
	{
		if(DigIO_No>DIGIO_NO_MAX || DigIO_No<DIGIO_NO_MIN)	//1..8
			RET_WRONG_PARAMETER;
	}
	else
	{
		if(DigIO_No>DIGIO_NO_MAX_EXT || DigIO_No<DIGIO_NO_MIN)	//1..12
			RET_WRONG_PARAMETER;
	}
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xB7;
	txbuf[1]= (char)DigIO_No;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +2; //Antwort-data= 2 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(2);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(2);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			if(gsvs[ComNo].Param_in_buf[8] == txbuf[1])
			{
				/*Itmp= GetBitValue((long)Ctmp, BitNo-1);
				if(Itmp==GSV_ERROR)*/
				Ctmp= gsvs[ComNo].Param_in_buf[9];
				if(Ctmp > DIGIOTYPE_REG_MAX)
					res= GSV_ERROR;
				else if (Ctmp >= DIGIOTYPE_RANGE_SW)	//Schwellwert-txpe: FW: 0x11..0x18 enum: d8..15
					Itmp= (int)(Ctmp - DIGIOTYPE_OFFSET_SW);
				else if (Ctmp >= DIGIOTYPE_RANGE_SYNC)	//neu ver 12: Sync-Funktion FW: 0x0F..0x10 enum: d16,17
					Itmp= (int)(Ctmp + DIGIOTYPE_OFFSET_SYNC);
				else if (Ctmp >= DIGIOTYPE_RANGE_TARA)	//Tara-Type: FW: 0x0A..0x0E, enum: d3..7
					Itmp= (int)(Ctmp - DIGIOTYPE_OFFSET_TARA);
				else
					Itmp= (int)Ctmp;
			}
			else
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res=GSV_ERROR;
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return (long)Itmp;	//(DigIOtype)
	else
		return res;
}
int CALLTYPE GSV4setDigitalIOtype(int ComNo, int DigIO_No, DigIOtype type)	//BitNo=0: alle Bits, sonst: 1..8
{
	unsigned char txbuf[4];
	DWORD Byteswritten;
	int res=GSV_OK, i, max, Tmax;
	
	CHECK_COMNO;
	CHECK_FW_VERSION(FW_VER_MIN_DIO);	//FW-ver min: 0x08??
	if(gsvs[ComNo].FWversion < FW_VER_MIN_DIO_EXT)
	{
		max= DIGIO_NO_MAX;
		Tmax= DIGIO_TYPE_NO_MAX;
	}
	else
	{
		max= DIGIO_NO_MAX_EXT;
		Tmax= DIGIO_TYPE_NO_MAX_EXT;
	}
	if(type > Tmax || DigIO_No>max || DigIO_No<0 || type<0)
		RET_WRONG_PARAMETER;
	
	txbuf[0]= 0xB6;
	if(type <= DIGIO_TYPE_GETVAL)
		txbuf[2]= (char)type;
	else if(type <= DIGIO_TYPE_ZERO_CH4)
		txbuf[2]= ((char)type) + DIGIOTYPE_OFFSET_TARA;
	else if(type <= DIGIO_TYPE_THRESNO_8)
		txbuf[2]= ((char)type) + DIGIOTYPE_OFFSET_SW;
	else txbuf[2]= ((char)type) - DIGIOTYPE_OFFSET_SYNC;
	/*if(DigIO_No)
	{			
		getVal= GSV4getDigitalDirection(ComNo, 0);
		if(getVal==GSV_ERROR)
			res=GSV_ERROR;
		else
		{
			msk= MakeBitMask(value, BitNo-1);
			if(value)
				txbuf[1]= (char)(getVal | msk);
			else
				txbuf[1]= (char)(getVal & msk);
		}
		
	}
	else
		txbuf[1]= (char)value;
 
	if(res==GSV_OK)
	{*/
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
		STOP_TX
#endif
	if(DigIO_No)
	{
		txbuf[1]= (char)DigIO_No;
		WRITE_BYTES_CHK_SUCC(3);
	}
	else
	{
		for(i=1;i<=max;i++)
		{
			txbuf[1]= (char)i;
			if(res != GSV_ERROR)
			{
				WRITE_BYTES_CHK_SUCC(3);
				Sleep(DELAY_BETWEEN_COMMANDS);		//
			}
		}
	}
#ifdef STOPTX_ON_SET_COMMAND
		START_TX
#endif
	return res;
}

long gsv4getDigitalIOval(int ComNo, int ext)	//intern
{
	char txbuf[4];
	DWORD Byteswritten;
	int res=GSV_TRUE, Itmp;
	//char Ctmp;
	if(ext)
		txbuf[0]= 0xBF;
	else
		txbuf[0]= 0xB9;
	//txbuf[1]= (char)(DigIO_No-1);

	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			Itmp= ((int)(gsvs[ComNo].Param_in_buf[8])) & 0xFF;
				//Itmp= (int)Ctmp;
		}
	}
	else
		RES_MUTEXFAILED;
	if(res==GSV_OK)
		return Itmp;
	else
		return res;
}

long CALLTYPE GSV4getDigitalIOvalue(int ComNo, int DigIO_No)	//BitNo=0: alle Bits, sonst: 1..8
{
	//char txbuf[4];
	//DWORD Byteswritten;
	int res=GSV_OK, Itmp;
	int DigMax; //,i;
	long Ltmp=0, msk;
	
	CHECK_COMNO;
	CHECK_FW_VERSION(0x08);	//FW-ver min: 0x08??
	if(gsvs[ComNo].FWversion >= FW_VER_MIN_DIO_EXT)
		DigMax= DIGIO_NO_MAX_EXT;
	else
		DigMax= DIGIO_NO_MAX;
	//if(DigIO_No> (gsvs[ComNo].FWversion >= 0x0A ? DIGIO_NO_MAX:DIGIO_NO_MAX_OLD) || DigIO_No<0)
	if(DigIO_No>DigMax || DigIO_No<0)
		RET_WRONG_PARAMETER
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	if(DigIO_No)
	{
		if(DigIO_No > 8)
			Itmp= gsv4getDigitalIOval(ComNo, 1);
		else
			Itmp= gsv4getDigitalIOval(ComNo, 0);
		if(Itmp == GSV_ERROR)
			res=GSV_ERROR;
		else
		{
			msk =1;
			if(DigIO_No > 8)
				msk <<= (DigIO_No-9);
			else
				msk <<= (DigIO_No-1);
			Ltmp= (msk & Itmp ? 1:0);
		}
	}
	else
	{
		Itmp= gsv4getDigitalIOval(ComNo, 0);
		if(Itmp == GSV_ERROR)
			res=GSV_ERROR;
		else
		{
			if(DigMax > DIGIO_NO_MAX)
			{
				Ltmp=gsv4getDigitalIOval(ComNo, 1);
				if(Ltmp == GSV_ERROR)
					res=GSV_ERROR;
				else
				{
					Ltmp <<= 8;
					Ltmp |= Itmp;
				}
			}
			else
				Ltmp= Itmp;
		}
	}
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return Ltmp;
	else
		return res;
}

int CALLTYPE GSV4setDigitalIOvalue(int ComNo, int DigIO_No, int value)	//BitNo=0: alle Bits, sonst: 1..8
{
	char txbuf[4];
	DWORD Byteswritten;
	int res=GSV_OK, i,DigMax;
	
	CHECK_COMNO;
	CHECK_FW_VERSION(0x08);	//FW-ver min: 0x08??
	if(gsvs[ComNo].FWversion >= FW_VER_MIN_DIO_EXT)
		DigMax= DIGIO_NO_MAX_EXT;
	else
		DigMax= DIGIO_NO_MAX;
	if(DigIO_No>DigMax || DigIO_No<0)
		RET_WRONG_PARAMETER
	
	txbuf[0]= 0xB8;
	txbuf[2]= (unsigned char)value;
	/*if(DigIO_No)
	{				// to do: STOP_TX-Saveval!!
		getVal= GSV4getDigital_IO(ComNo, 0);
		if(getVal==GSV_ERROR)
			res=GSV_ERROR;
		else
		{
			msk= MakeBitMask(value, BitNo-1);
			if(value)
				txbuf[1]= (char)(getVal | msk);
			else
				txbuf[1]= (char)(getVal & msk);
		}
	}
	else
		txbuf[1]= (char)value;
 
	if(res==GSV_OK)
	{*/
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
		STOP_TX
#endif
	if(DigIO_No)
	{
		txbuf[1]= (char)DigIO_No;
		WRITE_BYTES_CHK_SUCC(3);
			//Sleep(500);		//mit Thomas abklaeren!
	}
	else
	{
		for(i=1;i<=DigMax;i++)
		{
			if(res != GSV_ERROR)
			{
				txbuf[1]= (char)i;
				WRITE_BYTES_CHK_SUCC(3);
				Sleep(DELAY_BETWEEN_COMMANDS);
			}
		}
	}
#ifdef STOPTX_ON_SET_COMMAND
		START_TX
#endif
	return res;
}

int CALLTYPE GSV4setBaudCAN(int ComNo, long Bitrate)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_ERROR, i;
	char Bcode;
	static unsigned long CANbaudTable[]=
	{
		20000,50000,80000,100000,125000,250000,500000,1000000
	};
	static unsigned char CANbaudCode[]=
	{
		0x10,0x20,0x30,0x40,0x50,0x60,0x70,	0x80
	};
	
	CHECK_COMNO;
	for(i=0;i<CAN_BAUD_NO;i++)
	{
		if(Bitrate==CANbaudTable[i])
		{
			Bcode= CANbaudCode[i];
			res= GSV_OK;
			break;
		}
	}
	if(res != GSV_OK)
		RET_WRONG_PARAMETER;
	txbuf[0]= 0xC0;
	txbuf[1]= Bcode;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(2);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4getBaudCAN(int ComNo)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	long res=GSV_TRUE,i;
	unsigned long baud;
	unsigned char Bcode;
	static unsigned long CANbaudTable[]=
	{
		20000,50000,80000,100000,125000,250000,500000,1000000
	};
	static unsigned char CANbaudCode[]=
	{
		0x10,0x20,0x30,0x40,0x50,0x60,0x70,	0x80
	};
	
	CHECK_COMNO;
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xC1;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Byte
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);

		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			Bcode= gsvs[ComNo].Param_in_buf[8];
			res=GSV_ERROR;
			for(i=0;i<CAN_BAUD_NO;i++)
			{
				if(Bcode==CANbaudCode[i])
				{
					baud= CANbaudTable[i];
					res= GSV_OK;
					break;
				}
			}
			if(res!=GSV_OK)
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return baud;
	else
		return res;
}

int CALLTYPE GSV4setCanID(int ComNo, int IDno, long CanID)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	char* Bptr;
	long Ltmp;
	
	CHECK_COMNO;
	if(IDno<CANID_NO_MIN || IDno>CANID_NO_MAX)
		RET_WRONG_PARAMETER;
	Ltmp= CanID;
	Bptr= (char*)&Ltmp;
	txbuf[0]= 0xC5;
	txbuf[1]= (char)IDno;
	txbuf[2]= *(Bptr+3);
	txbuf[3]= *(Bptr+2);
	txbuf[4]= *(Bptr+1);
	txbuf[5]= *Bptr;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(6);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4getCanID(int ComNo, int IDno)
{
	unsigned char txbuf[2];
	DWORD Byteswritten;
	long res=GSV_TRUE;
	char* Bptr;
	long Ltmp;
	
	CHECK_COMNO;
	if(IDno<CANID_NO_MIN || IDno>CANID_NO_MAX)
		RET_WRONG_PARAMETER;
	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xC6;
	txbuf[1]= (char)IDno;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +5; //Antwort-data= 5 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(2);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(5);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			if(gsvs[ComNo].Param_in_buf[8]==txbuf[1])
			{
				Bptr= (char*)&Ltmp;
				*Bptr = gsvs[ComNo].Param_in_buf[12];		//ok? TESTEN!!
				*(Bptr+1)= gsvs[ComNo].Param_in_buf[11];
				*(Bptr+2)= gsvs[ComNo].Param_in_buf[10];
				*(Bptr+3)= gsvs[ComNo].Param_in_buf[9];
			}
			else
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res= GSV_ERROR;
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return Ltmp;
	else
		return res;
}

int CALLTYPE GSV4getTXmode(int ComNo)
{
	char txbuf[2];
	DWORD Byteswritten;
	long res=GSV_TRUE;
	int mode;
	
	CHECK_COMNO;
#ifdef _DEBUG
	if(ComNo==0)
		return 3;
#endif	
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x29;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +1; //Antwort-data= 1 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(1);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(1);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
			mode= (int)gsvs[ComNo].Param_in_buf[8];
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return mode;
	else
		return res;
}

int CALLTYPE GSV4setTXmode(int ComNo, int val)
{
	char txbuf[2];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;

	txbuf[0]= 0x28;
	txbuf[1]= (char)val;
#ifdef _DEBUG
	if(ComNo==0)
		return GSV_OK;
#endif
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(2);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

int CALLTYPE GSV4writeOffset(int ComNo, int Chan, int gain, long offset)
{
	char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
	CHECK_CHAN;
	if(gain<GAIN_MIN || gain>GAIN_MAX)
		RET_WRONG_PARAMETER;
	txbuf[0]= 0x0B;
	txbuf[1]= (char)Chan;
	txbuf[2]= (char)gain;
	txbuf[3]= (char)((offset >> 16) & 0xFF);
	txbuf[4]= (char)((offset >> 8) & 0xFF);
	txbuf[5]= (char)(offset & 0xFF);
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(6);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4readOffset(int ComNo, int Chan, int gain)
{
	char txbuf[4];
	DWORD Byteswritten;
	long res=GSV_TRUE, offset;

	CHECK_COMNO;
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
	CHECK_CHAN;
	if(gain<GAIN_MIN || gain>GAIN_MAX)
		RET_WRONG_PARAMETER;
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0x0D;
	txbuf[1]= (char)Chan;
	txbuf[2]= (char)gain;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +5; //Antwort-data= 5 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(3);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(5);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
				//Antwort-data: indizes 8..12. 8,9: Chan,gain
			if(gsvs[ComNo].Param_in_buf[8] != txbuf[1] || gsvs[ComNo].Param_in_buf[9] != txbuf[2]) //8,9: Chan,gain testen
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res= GSV_ERROR;
			}
			else
			{
				offset= (((long)gsvs[ComNo].Param_in_buf[10]) << 16) & 0x00FF0000;
				offset |= ((((long)gsvs[ComNo].Param_in_buf[11]) << 8) & 0x0000FF00);
				offset |= (((long)gsvs[ComNo].Param_in_buf[12]) & 0x000000FF);
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return offset;
	else
		return res;
}

int CALLTYPE GSV4setUnit(int ComNo, int Chan, long UnitNo)
{
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	
	CHECK_COMNO;
#ifndef _DEBUG
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
#endif
	CHECK_CHAN;
	if(UnitNo > UNIT_NO_MAX)
		RET_WRONG_PARAMETER;
	txbuf[0]= 0xB4;
	txbuf[1]= (char)Chan;
	txbuf[2]= (char)UnitNo;
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
	STOP_TX
#endif
	WRITE_BYTES_CHK_SUCC(3);
		//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
	START_TX
#endif
	return res;
}

long CALLTYPE GSV4getUnit(int ComNo, int Chan)
{
	unsigned char txbuf[4];
	DWORD Byteswritten;
	long res=GSV_TRUE, unit;

	CHECK_COMNO;
#ifndef _DEBUG
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
#endif
	CHECK_CHAN;
#ifdef STOPTX_ON_READ_COMMAND
	STOP_TX
#endif
	txbuf[0]= 0xB5;
	txbuf[1]= (char)Chan;
	if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
	{
		gsvs[ComNo].Param_in_count=0;
		gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE +2; //Antwort-data= 2 Bytes
		ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
		ResetEvent(gsvs[ComNo].Prd_event);
		WRITE_BYTES_CHK_SUCC(2);
	
		if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
			res= GSV_OK;
		else
			RES_NO_GSVANSWER;

		RES_CHK_PARAM_COUNT(2);
		
		if(res==GSV_OK)
		{
#ifdef RESPONSEFRAME_DEEPANALYSE
			//to do...
#endif
				//Antwort-data: indizes 8..9: Chan, unit
			if(gsvs[ComNo].Param_in_buf[8] != txbuf[1]) //8: Chan in Antwort testen
			{
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
				res= GSV_ERROR;
			}
			else
			{
				unit= (long)gsvs[ComNo].Param_in_buf[9];
			}
		}
	}
	else
		RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
	START_TX
#endif
	if(res==GSV_OK)
		return unit;
	else
		return res;

}

int CALLTYPE GSV4setUnitText(int ComNo, int Chan, char* UnitTxt)
{
	//char Tunit[8];
	int len,i, einhei;
	unsigned char txbuf[8];
	DWORD Byteswritten;
	int res=GSV_OK;
	char *Units[] =
	{
		"mV/V","kg","g","N","cN","V","m/m"," ","t","kN","lb","oz","kp","lbf","pdl","mm","m","cNm","Nm", //0..18
		"C","F","K","oztr","dwt","kNm","%","0/00","W","kW","rpm","bar","Pa","hPa","MPa","N/mm2","", //19..35
		"Hz","m/s","km/h","m3/h","mA","A","m/s2"	//36..42
	};

	CHECK_COMNO;
#ifndef _DEBUG
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
#endif
	CHECK_CHAN_ALL;

	len= strlen(UnitTxt);
	if(len > UNIT_LEN_MAX)
		RET_WRONG_PARAMETER;	//max strinlaenge =5
	if(!Chan)
	{		//Chan =0: "ganz neuen" set_user_strting Befehl nehmen
		txbuf[0]= 0xBC;
		if(len==0)
		{
			for(i=0;i<UNIT_LEN_MAX;i++)
				txbuf[i+1]= EMTY_UNIT_TXT_VAL; //sonderfall Laenge =0: Text loeschen: alle 5 bytes =0
		}
		else
		{
			for(i=0;i<len;i++)
				txbuf[i+1]= UnitTxt[i];
			for(i=len;i<UNIT_LEN_MAX;i++)
				txbuf[i+1]= 0;	//ggf. ungenutzte Bytes mit 0 ausffuellen
		}
#ifdef STOPTX_ON_SET_COMMAND	//hier noetig?? Klaeren!
		STOP_TX
#endif
		WRITE_BYTES_CHK_SUCC(UNIT_LEN_MAX+1);
			//Sleep(500);		//mit Thomas abklaeren!
#ifdef STOPTX_ON_SET_COMMAND
		START_TX
#endif
	}
	else	//Chan=1..4: UnitTxt vergleichen und ggf setzen
	{
		if(len==0)
		{
			einhei= 7;	//Laenge =0: Keine Einheit (No 7) setzen
			res=GSV_OK;
		}
		else
		{
			res= GSV_ERROR;
			for(i=0;i<=UNIT_NO_MAX;i++)
			{
				if(strcmp(Units[i],UnitTxt)==0)
				{
					einhei= i;	//uebergebene unit vorhanden: loop fertig
					res=GSV_OK;
					break;
				}
			}
		}
		if(res==GSV_OK)
			res= GSV4setUnit(ComNo, Chan, einhei);
	}
	return res;
}

int CALLTYPE GSV4getUnitText(int ComNo, int Chan, char* UnitTxt)
{
	char txbuf[4], Tmp[UNIT_LEN_MAX+2];
	DWORD Byteswritten;
	long res=GSV_TRUE, unit,i;
	char *Units[] =
	{
		"mV/V","kg","g","N","cN","V","m/m"," ","t","kN","lb","oz","kp","lbf","pdl","mm","m","cNm","Nm",
		"C","F","K","oztr","dwt","kNm","%","0/00","W","kW","rpm","bar","Pa","hPa","MPa","N/mm2","",
		"Hz","m/s","km/h","m3/h","mA","A","m/s2"
	};

	CHECK_COMNO;
#ifndef _DEBUG
	CHECK_FW_VERSION(0x0A);	//FW-ver min: 0x0A
#endif
	CHECK_CHAN_ALL;

	if(!Chan)
	{		//Chan =0: "ganz neuen" get_user_strting Befehl nehmen
#ifdef STOPTX_ON_READ_COMMAND
		STOP_TX
#endif
		txbuf[0]= 0xBD;
		if(WaitForSingleObject(gsvs[ComNo].Prd_mutex, INFINITE) != WAIT_FAILED) //(EnterGSVreadMutex(ComNo))
		{
			gsvs[ComNo].Param_in_count=0;
			gsvs[ComNo].Param_in_missing= RESPONSEFRAME_FIXEDSIZE + UNIT_LEN_MAX; //Antwort-data= 5 Bytes
			ReleaseMutex(gsvs[ComNo].Prd_mutex);	//dem Thread Parameterempfang ermoeglichen
			ResetEvent(gsvs[ComNo].Prd_event);
			WRITE_BYTES_CHK_SUCC(1);
		
			if(res==GSV_TRUE && WaitForSingleObject(gsvs[ComNo].Prd_event, PARAMRESPONSE_TIMEOUT)==WAIT_OBJECT_0)
				res= GSV_OK;
			else
				RES_NO_GSVANSWER;

			RES_CHK_PARAM_COUNT(UNIT_LEN_MAX);
			
			if(res==GSV_OK)
			{
#ifdef RESPONSEFRAME_DEEPANALYSE
				//to do...
#endif
					//Antwort-data: indizes 8..12
				if(gsvs[ComNo].Param_in_buf[8])
				{
					for(i=0;i<UNIT_LEN_MAX;i++)
					{
						Tmp[i]= gsvs[ComNo].Param_in_buf[8+i];
						if(Tmp[i]==0)	//terminier-0 gefunden: abbrechen
							break;
					}
					if(i==UNIT_LEN_MAX)
						Tmp[UNIT_LEN_MAX]=0;//ggf terminieren
					if(strcpy_s(UnitTxt, UNIT_LEN_MAX+1, &Tmp[0]) !=0)
						res=GSV_ERROR; //RET_WRONG_PARAMETER
				}
				else
					UnitTxt[0] =0;	//sonderfall: Textlaenge =0, da erstes Zeichen in Param_in_buf[8] =0
			}
		}
		else
			RES_MUTEXFAILED;
#ifdef STOPTX_ON_READ_COMMAND
		START_TX
#endif
	}
	else	//Chan 1..4: unitNo lesen
	{
		unit= GSV4getUnit(ComNo, Chan);
		if(unit != GSV_ERROR && unit <= UNIT_NO_MAX)
		{
			if(strcpy_s(UnitTxt, UNIT_LEN_MAX+1, Units[unit])==0)
				res= GSV_OK;
			else
			{
				gsvs[ComNo].LastError= ERR_WRONG_PARAMETER;
				res=GSV_ERROR;
			}
		}
		else
		{
			if(unit > UNIT_NO_MAX)
				gsvs[ComNo].LastError= ERR_WRONG_ANSWER;
			res=GSV_ERROR;
		}
	}
	return res;
}
